#ifndef __rai_raids__redis_cmd_h__
#define __rai_raids__redis_cmd_h__

/* file generated by redis_cmd < redis_cmd.adoc > redis_cmd.h */

#ifdef __cplusplus
extern "C" {
#endif

enum ds_category {
  NO_CATG                =  0,
  CONNECTION_CATG        =  1,
  SERVER_CATG            =  2,
  KEY_CATG               =  3,
  STRING_CATG            =  4,
  LIST_CATG              =  5,
  HASH_CATG              =  6,
  SET_CATG               =  7,
  SORTED_SET_CATG        =  8,
  GEO_CATG               =  9,
  HYPERLOGLOG_CATG       = 10,
  PUBSUB_CATG            = 11,
  TRANSACTION_CATG       = 12,
  STREAM_CATG            = 13
};

enum ds_command {
  NO_CMD                 =   0,
  /* Connection */
  ECHO_CMD               =   1,
  PING_CMD               =   2,
  QUIT_CMD               =   3,
  SELECT_CMD             =   4,
  /* Server */
  CLIENT_CMD             =   5,
  COMMAND_CMD            =   6,
  CONFIG_CMD             =   7,
  DBSIZE_CMD             =   8,
  DEBUG_CMD              =   9,
  FLUSHALL_CMD           =  10,
  FLUSHDB_CMD            =  11,
  INFO_CMD               =  12,
  MONITOR_CMD            =  13,
  SAVE_CMD               =  14,
  LOAD_CMD               =  15,
  SHUTDOWN_CMD           =  16,
  TIME_CMD               =  17,
  /* Key */
  DEL_CMD                =  18,
  DUMP_CMD               =  19,
  EXISTS_CMD             =  20,
  EXPIRE_CMD             =  21,
  EXPIREAT_CMD           =  22,
  KEYS_CMD               =  23,
  OBJECT_CMD             =  24,
  PERSIST_CMD            =  25,
  PEXPIRE_CMD            =  26,
  PEXPIREAT_CMD          =  27,
  PTTL_CMD               =  28,
  RANDOMKEY_CMD          =  29,
  RENAME_CMD             =  30,
  RENAMENX_CMD           =  31,
  RESTORE_CMD            =  32,
  TOUCH_CMD              =  33,
  TTL_CMD                =  34,
  TYPE_CMD               =  35,
  UNLINK_CMD             =  36,
  SCAN_CMD               =  37,
  /* String */
  APPEND_CMD             =  38,
  BITCOUNT_CMD           =  39,
  BITFIELD_CMD           =  40,
  BITOP_CMD              =  41,
  BITPOS_CMD             =  42,
  DECR_CMD               =  43,
  DECRBY_CMD             =  44,
  GET_CMD                =  45,
  GETBIT_CMD             =  46,
  GETRANGE_CMD           =  47,
  GETSET_CMD             =  48,
  INCR_CMD               =  49,
  INCRBY_CMD             =  50,
  INCRBYFLOAT_CMD        =  51,
  MGET_CMD               =  52,
  MSET_CMD               =  53,
  MSETNX_CMD             =  54,
  PSETEX_CMD             =  55,
  SET_CMD                =  56,
  SETBIT_CMD             =  57,
  SETEX_CMD              =  58,
  SETNX_CMD              =  59,
  SETRANGE_CMD           =  60,
  STRLEN_CMD             =  61,
  /* List */
  BLPOP_CMD              =  62,
  BRPOP_CMD              =  63,
  BRPOPLPUSH_CMD         =  64,
  LINDEX_CMD             =  65,
  LINSERT_CMD            =  66,
  LLEN_CMD               =  67,
  LPOP_CMD               =  68,
  LPUSH_CMD              =  69,
  LPUSHX_CMD             =  70,
  LRANGE_CMD             =  71,
  LREM_CMD               =  72,
  LSET_CMD               =  73,
  LTRIM_CMD              =  74,
  RPOP_CMD               =  75,
  RPOPLPUSH_CMD          =  76,
  RPUSH_CMD              =  77,
  RPUSHX_CMD             =  78,
  /* Hash */
  HAPPEND_CMD            =  79,
  HDEL_CMD               =  80,
  HEXISTS_CMD            =  81,
  HGET_CMD               =  82,
  HGETALL_CMD            =  83,
  HINCRBY_CMD            =  84,
  HINCRBYFLOAT_CMD       =  85,
  HKEYS_CMD              =  86,
  HLEN_CMD               =  87,
  HMGET_CMD              =  88,
  HMSET_CMD              =  89,
  HSET_CMD               =  90,
  HSETNX_CMD             =  91,
  HSTRLEN_CMD            =  92,
  HVALS_CMD              =  93,
  HSCAN_CMD              =  94,
  /* Set */
  SADD_CMD               =  95,
  SCARD_CMD              =  96,
  SDIFF_CMD              =  97,
  SDIFFSTORE_CMD         =  98,
  SINTER_CMD             =  99,
  SINTERSTORE_CMD        = 100,
  SISMEMBER_CMD          = 101,
  SMEMBERS_CMD           = 102,
  SMOVE_CMD              = 103,
  SPOP_CMD               = 104,
  SRANDMEMBER_CMD        = 105,
  SREM_CMD               = 106,
  SUNION_CMD             = 107,
  SUNIONSTORE_CMD        = 108,
  SSCAN_CMD              = 109,
  /* Sorted Set */
  ZADD_CMD               = 110,
  ZCARD_CMD              = 111,
  ZCOUNT_CMD             = 112,
  ZINCRBY_CMD            = 113,
  ZINTERSTORE_CMD        = 114,
  ZLEXCOUNT_CMD          = 115,
  ZRANGE_CMD             = 116,
  ZRANGEBYLEX_CMD        = 117,
  ZREVRANGEBYLEX_CMD     = 118,
  ZRANGEBYSCORE_CMD      = 119,
  ZRANK_CMD              = 120,
  ZREM_CMD               = 121,
  ZREMRANGEBYLEX_CMD     = 122,
  ZREMRANGEBYRANK_CMD    = 123,
  ZREMRANGEBYSCORE_CMD   = 124,
  ZREVRANGE_CMD          = 125,
  ZREVRANGEBYSCORE_CMD   = 126,
  ZREVRANK_CMD           = 127,
  ZSCORE_CMD             = 128,
  ZUNIONSTORE_CMD        = 129,
  ZSCAN_CMD              = 130,
  ZPOPMIN_CMD            = 131,
  ZPOPMAX_CMD            = 132,
  BZPOPMIN_CMD           = 133,
  BZPOPMAX_CMD           = 134,
  /* Geo */
  GEOADD_CMD             = 135,
  GEOHASH_CMD            = 136,
  GEOPOS_CMD             = 137,
  GEODIST_CMD            = 138,
  GEORADIUS_CMD          = 139,
  GEORADIUSBYMEMBER_CMD  = 140,
  /* Hyperloglog */
  PFADD_CMD              = 141,
  PFCOUNT_CMD            = 142,
  PFMERGE_CMD            = 143,
  /* Pubsub */
  PSUBSCRIBE_CMD         = 144,
  PUBSUB_CMD             = 145,
  PUBLISH_CMD            = 146,
  PUNSUBSCRIBE_CMD       = 147,
  SUBSCRIBE_CMD          = 148,
  UNSUBSCRIBE_CMD        = 149,
  /* Transaction */
  DISCARD_CMD            = 150,
  EXEC_CMD               = 151,
  MULTI_CMD              = 152,
  UNWATCH_CMD            = 153,
  WATCH_CMD              = 154,
  /* Stream */
  XINFO_CMD              = 155,
  XADD_CMD               = 156,
  XTRIM_CMD              = 157,
  XDEL_CMD               = 158,
  XRANGE_CMD             = 159,
  XREVRANGE_CMD          = 160,
  XLEN_CMD               = 161,
  XREAD_CMD              = 162,
  XGROUP_CMD             = 163,
  XREADGROUP_CMD         = 164,
  XACK_CMD               = 165,
  XCLAIM_CMD             = 166,
  XPENDING_CMD           = 167,
  XSETID_CMD             = 168
};

typedef struct ds_s ds_t;
typedef struct ds_msg_s ds_msg_t;

#ifndef REDIS_XTRA
/* The function signatures used below: K = key, A = arg, O = optional */
#define _F_( cmd ) ;
#define _F_A( cmd ) ;
#define _F_AA( cmd ) ;
#define _F_AKKO( cmd ) ;
#define _F_AO( cmd ) ;
#define _F_K( cmd ) ;
#define _F_KA( cmd ) ;
#define _F_KAA( cmd ) ;
#define _F_KAAA( cmd ) ;
#define _F_KAAAAO( cmd ) ;
#define _F_KAAAO( cmd ) ;
#define _F_KAAO( cmd ) ;
#define _F_KAO( cmd ) ;
#define _F_KK( cmd ) ;
#define _F_KKA( cmd ) ;
#define _F_KKO( cmd ) ;
#define _F_KO( cmd ) ;
#define _F_O( cmd ) ;
#endif
/* _F_CRC checks that the generated funs are defined in redis_cmd_db.cpp */
/* this forces all of the following decls to be available */
#define _F_CRC 0x10e651ffU
#define _F_CNT 18

/* The ds_ functions are defined in the library (redis_cmd_db.cpp) to keep
   them independent of CMD enum changes above;  the library interface will
   stay the same after cmds are added, but the enums may be reordered */

/* echo string */
int ds_echo( ds_t *h, ds_msg_t *r, ds_msg_t *arg ) _F_A( ECHO_CMD )
/* ping [string] */
int ds_ping( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( PING_CMD )
/* quit */
int ds_quit( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( QUIT_CMD )
/* select db */
int ds_select( ds_t *h, ds_msg_t *r, ds_msg_t *arg ) _F_A( SELECT_CMD )
/* client [setname name | getname | id | kill match | list match |
        reply state] */
int ds_client( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( CLIENT_CMD )
/* command [count | getkeys <cmd-full> | info [cmd] | help] */
int ds_command( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( COMMAND_CMD )
/* config [get <param> | rewrite | set <param> <value> | resetstat] */
int ds_config( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( CONFIG_CMD )
/* dbsize  */
int ds_dbsize( ds_t *h, ds_msg_t *r ) _F_( DBSIZE_CMD )
/* debug [object key | htstats] */
int ds_debug( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( DEBUG_CMD )
/* flushall [async] */
int ds_flushall( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( FLUSHALL_CMD )
/* flushdb [async] */
int ds_flushdb( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( FLUSHDB_CMD )
/* info [server | clients | memory | persistence | stats |
      replication | cpu | commandstats | cluster | keyspace] */
int ds_info( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( INFO_CMD )
/* monitor  */
int ds_monitor( ds_t *h, ds_msg_t *r ) _F_( MONITOR_CMD )
/* save  */
int ds_save( ds_t *h, ds_msg_t *r ) _F_( SAVE_CMD )
/* load */
int ds_load( ds_t *h, ds_msg_t *r ) _F_( LOAD_CMD )
/* shutdown */
int ds_shutdown( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( SHUTDOWN_CMD )
/* time  */
int ds_time( ds_t *h, ds_msg_t *r ) _F_( TIME_CMD )
/* del key [key ...] */
int ds_del( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( DEL_CMD )
/* dump key */
int ds_dump( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( DUMP_CMD )
/* exists key [key ...] */
int ds_exists( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( EXISTS_CMD )
/* expire key secs */
int ds_expire( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( EXPIRE_CMD )
/* expireat key stamp */
int ds_expireat( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( EXPIREAT_CMD )
/* keys pattern */
int ds_keys( ds_t *h, ds_msg_t *r, ds_msg_t *arg ) _F_A( KEYS_CMD )
/* object [refcount key | encoding key | idletime key | freq key | help] */
int ds_object( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( OBJECT_CMD )
/* persist key */
int ds_persist( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( PERSIST_CMD )
/* pexpire key ms */
int ds_pexpire( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( PEXPIRE_CMD )
/* pexpireat key ms */
int ds_pexpireat( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( PEXPIREAT_CMD )
/* pttl key */
int ds_pttl( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( PTTL_CMD )
/* randomkey  */
int ds_randomkey( ds_t *h, ds_msg_t *r ) _F_( RANDOMKEY_CMD )
/* rename key newkey */
int ds_rename( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2 ) _F_KK( RENAME_CMD )
/* renamenx key newkey */
int ds_renamenx( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2 ) _F_KK( RENAMENX_CMD )
/* restore key ttl value [replace] [absttl] [idletime idle] [freq lfu] */
int ds_restore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( RESTORE_CMD )
/* touch key [key ...] */
int ds_touch( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( TOUCH_CMD )
/* ttl key */
int ds_ttl( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( TTL_CMD )
/* type key */
int ds_type( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( TYPE_CMD )
/* unlink key [key ...] */
int ds_unlink( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( UNLINK_CMD )
/* scan curs [match pat] [count int] */
int ds_scan( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( SCAN_CMD )
/* append key value */
int ds_append( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( APPEND_CMD )
/* bitcount key [start end] */
int ds_bitcount( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( BITCOUNT_CMD )
/* bitfield key [get type off] [set type off value]
 [incrby type off incr] [overflow wrap | sat | fail] */
int ds_bitfield( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( BITFIELD_CMD )
/* bitop (and | or | xor | not) dest src [src src ...] */
int ds_bitop( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *key, ds_msg_t *key2, ds_msg_t *opt, ... ) _F_AKKO( BITOP_CMD )
/* bitpos key bit [start end] */
int ds_bitpos( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( BITPOS_CMD )
/* decr key */
int ds_decr( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( DECR_CMD )
/* decrby key int */
int ds_decrby( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( DECRBY_CMD )
/* get key */
int ds_get( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( GET_CMD )
/* getbit key off */
int ds_getbit( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( GETBIT_CMD )
/* getrange key start end */
int ds_getrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( GETRANGE_CMD )
/* getset key value */
int ds_getset( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( GETSET_CMD )
/* incr key */
int ds_incr( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( INCR_CMD )
/* incrby key int */
int ds_incrby( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( INCRBY_CMD )
/* incrbyfloat key decimal */
int ds_incrbyfloat( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( INCRBYFLOAT_CMD )
/* mget key [key ...] */
int ds_mget( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( MGET_CMD )
/* mset key val [key val ...] */
int ds_mset( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( MSET_CMD )
/* msetnx key val [key val ...] */
int ds_msetnx( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( MSETNX_CMD )
/* psetex key ms val */
int ds_psetex( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( PSETEX_CMD )
/* set key val [ex secs] [px ms] [nx | xx] */
int ds_set( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( SET_CMD )
/* setbit key off 1 | 0 */
int ds_setbit( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( SETBIT_CMD )
/* setex key secs val */
int ds_setex( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( SETEX_CMD )
/* setnx key val */
int ds_setnx( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( SETNX_CMD )
/* setrange key off val */
int ds_setrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( SETRANGE_CMD )
/* strlen key */
int ds_strlen( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( STRLEN_CMD )
/* blpop key [key ...] timeout */
int ds_blpop( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( BLPOP_CMD )
/* brpop key [key ...] timeout */
int ds_brpop( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( BRPOP_CMD )
/* brpoplpush src dest timeout */
int ds_brpoplpush( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2, ds_msg_t *arg ) _F_KKA( BRPOPLPUSH_CMD )
/* lindex key idx */
int ds_lindex( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( LINDEX_CMD )
/* linsert key before | after piv val */
int ds_linsert( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *arg3 ) _F_KAAA( LINSERT_CMD )
/* llen key */
int ds_llen( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( LLEN_CMD )
/* lpop key */
int ds_lpop( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( LPOP_CMD )
/* lpush key val [val ..] */
int ds_lpush( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( LPUSH_CMD )
/* lpushx key val [val ..] */
int ds_lpushx( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( LPUSHX_CMD )
/* lrange key start stop */
int ds_lrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( LRANGE_CMD )
/* lrem key count value */
int ds_lrem( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( LREM_CMD )
/* lset key idx value */
int ds_lset( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( LSET_CMD )
/* ltrim key start stop */
int ds_ltrim( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( LTRIM_CMD )
/* rpop key */
int ds_rpop( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( RPOP_CMD )
/* rpoplpush src dest */
int ds_rpoplpush( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2 ) _F_KK( RPOPLPUSH_CMD )
/* rpush key [val ...] */
int ds_rpush( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( RPUSH_CMD )
/* rpushx key [val ...] */
int ds_rpushx( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( RPUSHX_CMD )
/* happend key field val [val ...] */
int ds_happend( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( HAPPEND_CMD )
/* hdel key field [field ...] */
int ds_hdel( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( HDEL_CMD )
/* hexists key field */
int ds_hexists( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( HEXISTS_CMD )
/* hget key field */
int ds_hget( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( HGET_CMD )
/* hgetall key */
int ds_hgetall( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( HGETALL_CMD )
/* hincrby key field int */
int ds_hincrby( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( HINCRBY_CMD )
/* hincrbyfloat key field num */
int ds_hincrbyfloat( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( HINCRBYFLOAT_CMD )
/* hkeys key */
int ds_hkeys( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( HKEYS_CMD )
/* hlen key */
int ds_hlen( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( HLEN_CMD )
/* hmget key field [field ...] */
int ds_hmget( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( HMGET_CMD )
/* hmset key field value [field value ...] */
int ds_hmset( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( HMSET_CMD )
/* hset key field value [field value ...] */
int ds_hset( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( HSET_CMD )
/* hsetnx key field value */
int ds_hsetnx( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( HSETNX_CMD )
/* hstrlen key field */
int ds_hstrlen( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( HSTRLEN_CMD )
/* hvals key */
int ds_hvals( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( HVALS_CMD )
/* hscan key cursor [match pattern] [count int] */
int ds_hscan( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( HSCAN_CMD )
/* sadd key mem [mem ...] */
int ds_sadd( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( SADD_CMD )
/* scard key */
int ds_scard( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( SCARD_CMD )
/* sdiff key [key ...] */
int ds_sdiff( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( SDIFF_CMD )
/* sdiffstore dest key [key ...] */
int ds_sdiffstore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2, ds_msg_t *opt, ... ) _F_KKO( SDIFFSTORE_CMD )
/* sinter key [key ...] */
int ds_sinter( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( SINTER_CMD )
/* sinterstore key [key ...] */
int ds_sinterstore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2, ds_msg_t *opt, ... ) _F_KKO( SINTERSTORE_CMD )
/* sismember key mem */
int ds_sismember( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( SISMEMBER_CMD )
/* smembers key */
int ds_smembers( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( SMEMBERS_CMD )
/* smove src dest mem */
int ds_smove( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2, ds_msg_t *arg ) _F_KKA( SMOVE_CMD )
/* spop key [count] */
int ds_spop( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( SPOP_CMD )
/* srandmember key [count] */
int ds_srandmember( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( SRANDMEMBER_CMD )
/* srem key mem [mem ...] */
int ds_srem( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( SREM_CMD )
/* sunion key [key ...] */
int ds_sunion( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( SUNION_CMD )
/* sunionstore dest key [key ...] */
int ds_sunionstore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *key2, ds_msg_t *opt, ... ) _F_KKO( SUNIONSTORE_CMD )
/* sscan key curs [match pattern] [count cnt] */
int ds_sscan( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( SSCAN_CMD )
/* zadd key [nx | xx] [ch] [incr] score mem [score mem ...] */
int ds_zadd( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZADD_CMD )
/* zcard key */
int ds_zcard( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( ZCARD_CMD )
/* zcount key min max */
int ds_zcount( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( ZCOUNT_CMD )
/* zincrby key incr mem */
int ds_zincrby( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( ZINCRBY_CMD )
/* zinterstore dest num key [key ...] [weights w [w ...]]
 [aggregate sum|min|max] */
int ds_zinterstore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZINTERSTORE_CMD )
/* zlexcount key min max */
int ds_zlexcount( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( ZLEXCOUNT_CMD )
/* zrange key start stop [withscores] */
int ds_zrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZRANGE_CMD )
/* zrangebylex key min max [limit off cnt] */
int ds_zrangebylex( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZRANGEBYLEX_CMD )
/* zrevrangebylex key min max [limit off cnt] */
int ds_zrevrangebylex( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZREVRANGEBYLEX_CMD )
/* zrangebyscore key min max [withscores] */
int ds_zrangebyscore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZRANGEBYSCORE_CMD )
/* zrank key mem */
int ds_zrank( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( ZRANK_CMD )
/* zrem key mem [mem ...] */
int ds_zrem( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( ZREM_CMD )
/* zremrangebylex key min max */
int ds_zremrangebylex( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( ZREMRANGEBYLEX_CMD )
/* zremrangebyrank key start stop */
int ds_zremrangebyrank( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( ZREMRANGEBYRANK_CMD )
/* zremrangebyscore key start stop */
int ds_zremrangebyscore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( ZREMRANGEBYSCORE_CMD )
/* zrevrange key start stop [withscores] */
int ds_zrevrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZREVRANGE_CMD )
/* zrevrangebyscore key start stop [withscores] [limit off cnt] */
int ds_zrevrangebyscore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZREVRANGEBYSCORE_CMD )
/* zrevrank key mem */
int ds_zrevrank( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( ZREVRANK_CMD )
/* zscore key mem */
int ds_zscore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg ) _F_KA( ZSCORE_CMD )
/* zunionstore dest num key [key ...] [weights w [w ...]]
 [aggregate sum|min|max] */
int ds_zunionstore( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( ZUNIONSTORE_CMD )
/* zscan key curs [match pattern] [count cnt] */
int ds_zscan( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( ZSCAN_CMD )
/* zpopmin key [count] */
int ds_zpopmin( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( ZPOPMIN_CMD )
/* zpopmax key [count] */
int ds_zpopmax( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( ZPOPMAX_CMD )
/* bzpopmin key [key ...] timeout */
int ds_bzpopmin( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( BZPOPMIN_CMD )
/* bzpopmax key [key ...] timeout */
int ds_bzpopmax( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( BZPOPMAX_CMD )
/* geoadd key long lat mem [long lat mem ...] */
int ds_geoadd( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *arg3, ds_msg_t *opt, ... ) _F_KAAAO( GEOADD_CMD )
/* geohash key mem [mem ...] */
int ds_geohash( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( GEOHASH_CMD )
/* geopos key [mem ...] */
int ds_geopos( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( GEOPOS_CMD )
/* geodist key mem1 mem2 [unit] */
int ds_geodist( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( GEODIST_CMD )
/* georadius key long lat rad m | k | ft | mi [withcoord] [withdist]
 [withhash] [count n] [asc | desc] [storedist key] */
int ds_georadius( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *arg3, ds_msg_t *arg4, ds_msg_t *opt, ... ) _F_KAAAAO( GEORADIUS_CMD )
/* georadiusbymember key member rad m | k | ft | mi [withcoord]
 [withdist] [withhash] [count n] [asc | desc] [storedist key] */
int ds_georadiusbymember( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *arg3, ds_msg_t *opt, ... ) _F_KAAAO( GEORADIUSBYMEMBER_CMD )
/* pfadd key elem [elem ...] */
int ds_pfadd( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( PFADD_CMD )
/* pfcount key [key ...] */
int ds_pfcount( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( PFCOUNT_CMD )
/* pfmerge dkey skey [skey ...] */
int ds_pfmerge( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( PFMERGE_CMD )
/* psubscribe pat [pat ...] */
int ds_psubscribe( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( PSUBSCRIBE_CMD )
/* pubsub [channels [pattern] | numsub channel | numpat] */
int ds_pubsub( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( PUBSUB_CMD )
/* publish channel msg */
int ds_publish( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *arg2 ) _F_AA( PUBLISH_CMD )
/* punsubscribe [pat ...] */
int ds_punsubscribe( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( PUNSUBSCRIBE_CMD )
/* subscribe chan [chan ...] */
int ds_subscribe( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( SUBSCRIBE_CMD )
/* unsubscribe [chan ...] */
int ds_unsubscribe( ds_t *h, ds_msg_t *r, ds_msg_t *opt, ... ) _F_O( UNSUBSCRIBE_CMD )
/* discard  */
int ds_discard( ds_t *h, ds_msg_t *r ) _F_( DISCARD_CMD )
/* exec  */
int ds_exec( ds_t *h, ds_msg_t *r ) _F_( EXEC_CMD )
/* multi  */
int ds_multi( ds_t *h, ds_msg_t *r ) _F_( MULTI_CMD )
/* unwatch  */
int ds_unwatch( ds_t *h, ds_msg_t *r ) _F_( UNWATCH_CMD )
/* watch key [key ...] */
int ds_watch( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( WATCH_CMD )
/* xinfo [consumers key groupname] [groups key] [stream key] */
int ds_xinfo( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( XINFO_CMD )
/* xadd key id field string [field string ...] */
int ds_xadd( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *arg3, ds_msg_t *opt, ... ) _F_KAAAO( XADD_CMD )
/* xtrim key maxlen [~] count */
int ds_xtrim( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( XTRIM_CMD )
/* xdel key id [id ...] */
int ds_xdel( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *opt, ... ) _F_KO( XDEL_CMD )
/* xrange key start end [count cnt] */
int ds_xrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( XRANGE_CMD )
/* xrevrange key start end [count cnt] */
int ds_xrevrange( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( XREVRANGE_CMD )
/* xlen key */
int ds_xlen( ds_t *h, ds_msg_t *r, ds_msg_t *key ) _F_K( XLEN_CMD )
/* xread [count cnt] [block ms] streams key [key ...] id [id ...] */
int ds_xread( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( XREAD_CMD )
/* xgroup [create key grp id [mkstream]] [setid key grp id]
 [destroy key grp] [delconsumer key grp cname] */
int ds_xgroup( ds_t *h, ds_msg_t *r, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_AO( XGROUP_CMD )
/* xreadgroup group grp consumer [count cnt] [block ms] [noack]
 streams key [key ...] id [id ...] */
int ds_xreadgroup( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( XREADGROUP_CMD )
/* xack key grp id [id ...] */
int ds_xack( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *opt, ... ) _F_KAAO( XACK_CMD )
/* xclaim key grp consumer min-idle-time id [id ...] [idle ms]
[time ms-utc] [retrycount cnt] [force] [justid] */
int ds_xclaim( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2, ds_msg_t *arg3, ds_msg_t *opt, ... ) _F_KAAAO( XCLAIM_CMD )
/* xpending key grp [start end count] [consumer] */
int ds_xpending( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *opt, ... ) _F_KAO( XPENDING_CMD )
/* xsetid key grp id */
int ds_xsetid( ds_t *h, ds_msg_t *r, ds_msg_t *key, ds_msg_t *arg, ds_msg_t *arg2 ) _F_KAA( XSETID_CMD )

#ifdef __cplusplus
}

#include <raids/redis_cmd_db.h>
#include <raikv/key_hash.h>

namespace rai {
namespace ds {

typedef enum ds_category RedisCatg;
typedef enum ds_command  RedisCmd;

static const uint8_t cmd_hash_ht[ 1024 ] = {
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,0,0,0,166,0,0,0,0,0,0,0,0,0,142,
0,0,0,0,0,52,0,83,0,0,88,0,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,50,0,148,0,0,
0,0,0,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,107,0,42,0,0,0,0,0,0,59,0,133,0,0,0,0,0,0,0,155,0,0,0,
0,69,0,0,0,0,0,0,0,117,0,0,5,0,98,0,0,0,0,0,128,0,0,0,0,130,0,0,0,0,0,0,
41,0,0,22,109,102,0,0,0,0,0,0,0,0,0,0,0,0,0,157,0,0,0,0,0,0,168,0,0,80,0,0,
0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,0,0,0,110,0,81,
0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,64,114,0,0,0,0,0,0,0,92,0,0,0,0,0,
0,0,0,0,0,0,150,0,0,0,0,0,0,0,78,0,54,0,0,0,0,0,146,0,0,0,0,0,0,0,84,7,
0,0,0,0,0,0,104,34,0,0,0,0,0,103,0,0,0,0,0,0,0,0,0,0,0,0,10,131,0,0,0,0,
149,0,0,66,0,0,0,0,0,0,0,101,0,0,0,0,0,0,0,33,0,0,0,0,35,0,0,18,0,0,0,0,
0,0,0,0,123,0,0,71,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,29,0,0,0,91,0,
158,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,135,0,112,0,0,0,0,1,0,
12,0,0,105,0,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,0,53,0,0,141,0,89,0,0,0,0,0,
0,0,0,0,0,0,0,31,0,0,0,143,0,0,0,0,72,0,118,0,0,0,129,4,0,0,0,0,0,0,0,61,
144,0,0,145,0,0,0,0,0,0,0,0,8,0,0,0,127,0,0,0,0,60,0,0,0,0,20,0,0,0,0,0,
0,0,0,0,132,0,0,0,0,0,0,0,0,0,0,0,0,0,94,0,0,0,0,0,0,0,28,0,0,37,0,0,
0,0,0,0,0,0,0,0,113,0,0,0,47,0,159,0,0,0,0,0,0,0,167,0,0,0,0,0,0,165,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,154,0,0,0,0,0,51,0,25,0,0,0,99,0,19,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55,0,
0,36,0,0,0,0,0,163,45,111,0,76,0,0,0,87,39,0,0,0,79,0,0,0,0,0,0,70,0,0,0,121,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,96,0,0,24,125,0,0,0,136,0,0,0,
0,0,0,0,0,0,137,0,0,0,0,0,0,120,0,0,0,0,0,138,0,0,0,0,0,0,0,0,0,2,0,0,
0,0,0,0,0,0,0,0,0,0,48,15,0,116,3,0,0,119,0,0,0,0,0,0,0,0,0,93,27,0,90,100,
0,0,0,0,0,0,0,0,0,0,0,0,0,73,0,0,0,152,0,0,0,0,0,0,56,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,115,77,0,0,0,44,0,0,0,0,0,0,147,68,0,0,0,0,153,0,0,0,
17,0,0,0,0,0,0,85,0,0,0,134,0,0,0,0,0,0,0,58,23,0,162,0,63,0,0,86,156,0,0,0,
0,151,139,0,0,0,0,65,0,0,0,0,0,0,82,0,0,0,0,0,0,0,0,0,0,0,46,0,67,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,124,0,0,0,0,75,0,
0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,0,0,38,161,30,0,0,0,49,0,0,0,0,0,0,26,0,
0,106,0,0,0,122,0,0,0,164,0,0,0,11,0,0,74,0,0,0,0,0,0,0,0,0,0,108,0,0,0,0,
6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,62,0,0,0,40,0,0,0,0,0,0,0,0,0,0};

static inline uint32_t
get_redis_cmd_hash( const void *cmd,  size_t len ) {
  uint32_t out[ MAX_CMD_LEN / 4 ];
  for ( size_t i = 0; i * 4 < len; i++ )
    out[ i ] = ((const uint32_t *) cmd)[ i ] & 0xdfdfdfdfU;
  return kv_crc_c( out, len, 0x36fbdccd );
}

static inline RedisCmd
get_redis_cmd( uint32_t h ) {
  return (RedisCmd) cmd_hash_ht[ h % 1024 ];
}

extern const RedisCmdExtra xtra[ 856 ];

static const size_t REDIS_CMD_DB_SIZE = 169;
static const RedisCmdData
cmd_db[ REDIS_CMD_DB_SIZE ] = {
{ "none",NULL,0,NO_CMD,CMD_NOFLAGS,4,NO_CATG,0,0,0,0 },
{ "echo",&xtra[0],0x9580359e,ECHO_CMD,CMD_NOFLAGS,4,CONNECTION_CATG,2,0,0,0 },
{ "ping",&xtra[5],0x4eab7add,PING_CMD,CMD_NOFLAGS,4,CONNECTION_CATG,-1,0,0,0 },
{ "quit",&xtra[10],0x3ca0caee,QUIT_CMD,CMD_NOFLAGS,4,CONNECTION_CATG,-1,0,0,0 },
{ "select",&xtra[15],0x5d8ee9d7,SELECT_CMD,CMD_NOFLAGS,6,CONNECTION_CATG,2,0,0,0 },
{ "client",&xtra[19],0x6af1c8c,CLIENT_CMD,CMD_ADMIN_FLAG,6,SERVER_CATG,-2,0,0,0 },
{ "command",&xtra[33],0xa2da9fe0,COMMAND_CMD,CMD_NOFLAGS,7,SERVER_CATG,-1,0,0,0 },
{ "config",&xtra[38],0xc4d1291f,CONFIG_CMD,CMD_ADMIN_FLAG,6,SERVER_CATG,-2,0,0,0 },
{ "dbsize",&xtra[42],0x405435ec,DBSIZE_CMD,CMD_NOFLAGS,6,SERVER_CATG,1,0,0,0 },
{ "debug",&xtra[47],0xa50aa993,DEBUG_CMD,CMD_ADMIN_FLAG,5,SERVER_CATG,-1,0,0,0 },
{ "flushall",&xtra[54],0xbf12593a,FLUSHALL_CMD,CMD_ADMIN_FLAG,8,SERVER_CATG,-1,0,0,0 },
{ "flushdb",&xtra[58],0xcb45afcd,FLUSHDB_CMD,CMD_ADMIN_FLAG,7,SERVER_CATG,-1,0,0,0 },
{ "info",&xtra[62],0xeff3fda0,INFO_CMD,CMD_NOFLAGS,4,SERVER_CATG,-1,0,0,0 },
{ "monitor",&xtra[67],0xc4608ceb,MONITOR_CMD,CMD_ADMIN_FLAG,7,SERVER_CATG,1,0,0,0 },
{ "save",&xtra[72],0x57328fef,SAVE_CMD,CMD_ADMIN_FLAG,4,SERVER_CATG,1,0,0,0 },
{ "load",&xtra[76],0xf3196eb,LOAD_CMD,CMD_ADMIN_FLAG,4,SERVER_CATG,1,0,0,0 },
{ "shutdown",&xtra[80],0x4d5814c1,SHUTDOWN_CMD,CMD_ADMIN_FLAG,8,SERVER_CATG,-1,0,0,0 },
{ "time",&xtra[83],0xe0559340,TIME_CMD,CMD_NOFLAGS,4,SERVER_CATG,1,0,0,0 },
{ "del",&xtra[88],0x3a589d5b,DEL_CMD,CMD_WRITE_FLAG,3,KEY_CATG,-2,1,-1,1 },
{ "dump",&xtra[93],0xfab3165b,DUMP_CMD,CMD_READ_FLAG,4,KEY_CATG,2,1,1,1 },
{ "exists",&xtra[98],0xf0fcb9fa,EXISTS_CMD,CMD_READ_FLAG,6,KEY_CATG,-2,1,-1,1 },
{ "expire",&xtra[103],0x6a35a16e,EXPIRE_CMD,CMD_WRITE_FLAG,6,KEY_CATG,3,1,1,1 },
{ "expireat",&xtra[108],0x5e6df8a3,EXPIREAT_CMD,CMD_WRITE_FLAG,8,KEY_CATG,3,1,1,1 },
{ "keys",&xtra[113],0x74ad354,KEYS_CMD,CMD_READ_FLAG,4,KEY_CATG,2,0,0,0 },
{ "object",&xtra[118],0x2342eab7,OBJECT_CMD,CMD_READ_FLAG,6,KEY_CATG,-2,2,2,2 },
{ "persist",&xtra[123],0xd3ae3e55,PERSIST_CMD,CMD_WRITE_FLAG,7,KEY_CATG,2,1,1,1 },
{ "pexpire",&xtra[128],0xf55ebfbe,PEXPIRE_CMD,CMD_WRITE_FLAG,7,KEY_CATG,3,1,1,1 },
{ "pexpireat",&xtra[133],0xd95ad2fc,PEXPIREAT_CMD,CMD_WRITE_FLAG,9,KEY_CATG,3,1,1,1 },
{ "pttl",&xtra[138],0x21daa61a,PTTL_CMD,CMD_READ_FLAG,4,KEY_CATG,2,1,1,1 },
{ "randomkey",&xtra[143],0x97057a,RANDOMKEY_CMD,CMD_READ_FLAG,9,KEY_CATG,1,0,0,0 },
{ "rename",&xtra[148],0x85e9d3b3,RENAME_CMD,CMD_WRITE_FLAG,6,KEY_CATG,3,1,2,1 },
{ "renamenx",&xtra[153],0x9fd901c7,RENAMENX_CMD,CMD_WRITE_FLAG,8,KEY_CATG,3,1,2,1 },
{ "restore",&xtra[158],0x29f9aaf,RESTORE_CMD,CMD_WRITE_FLAG,7,KEY_CATG,-4,1,1,1 },
{ "touch",&xtra[162],0x6f400d53,TOUCH_CMD,CMD_WRITE_FLAG,5,KEY_CATG,-2,1,1,1 },
{ "ttl",&xtra[167],0x669d8927,TTL_CMD,CMD_READ_FLAG,3,KEY_CATG,2,1,1,1 },
{ "type",&xtra[172],0x6f0e2558,TYPE_CMD,CMD_READ_FLAG,4,KEY_CATG,2,1,1,1 },
{ "unlink",&xtra[177],0x915d9e81,UNLINK_CMD,CMD_WRITE_FLAG,6,KEY_CATG,-2,1,-1,1 },
{ "scan",&xtra[182],0xc47c4e1d,SCAN_CMD,CMD_READ_FLAG,4,KEY_CATG,-2,0,0,0 },
{ "append",&xtra[187],0xa518d7b1,APPEND_CMD,CMD_WRITE_FLAG,6,STRING_CATG,3,1,1,1 },
{ "bitcount",&xtra[192],0x7940f690,BITCOUNT_CMD,CMD_READ_FLAG,8,STRING_CATG,-2,1,1,1 },
{ "bitfield",&xtra[197],0x22e8bff5,BITFIELD_CMD,CMD_WRITE_FLAG,8,STRING_CATG,-2,1,1,1 },
{ "bitop",&xtra[208],0x5818b0a0,BITOP_CMD,CMD_WRITE_FLAG,5,STRING_CATG,-4,2,-1,1 },
{ "bitpos",&xtra[213],0x4d9586b,BITPOS_CMD,CMD_READ_FLAG,6,STRING_CATG,-3,1,1,1 },
{ "decr",&xtra[218],0x9ff189ac,DECR_CMD,CMD_WRITE_FLAG,4,STRING_CATG,2,1,1,1 },
{ "decrby",&xtra[223],0x5c57332f,DECRBY_CMD,CMD_WRITE_FLAG,6,STRING_CATG,3,1,1,1 },
{ "get",&xtra[228],0x4af1c288,GET_CMD,CMD_READ_FLAG,3,STRING_CATG,2,1,1,1 },
{ "getbit",&xtra[233],0xfef6ab7a,GETBIT_CMD,CMD_READ_FLAG,6,STRING_CATG,3,1,1,1 },
{ "getrange",&xtra[238],0xb1c0d22c,GETRANGE_CMD,CMD_READ_FLAG,8,STRING_CATG,4,1,1,1 },
{ "getset",&xtra[243],0xf88be6ea,GETSET_CMD,CMD_WRITE_FLAG,6,STRING_CATG,3,1,1,1 },
{ "incr",&xtra[248],0x1dad8fb7,INCR_CMD,CMD_WRITE_FLAG,4,STRING_CATG,2,1,1,1 },
{ "incrby",&xtra[253],0xecc0cc3b,INCRBY_CMD,CMD_WRITE_FLAG,6,STRING_CATG,3,1,1,1 },
{ "incrbyfloat",&xtra[258],0xf905ee53,INCRBYFLOAT_CMD,CMD_WRITE_FLAG,11,STRING_CATG,3,1,1,1 },
{ "mget",&xtra[263],0xb4f1a425,MGET_CMD,CMD_READ_FLAG,4,STRING_CATG,-2,1,-1,1 },
{ "mset",&xtra[268],0x5a8d7db5,MSET_CMD,CMD_WRITE_FLAG,4,STRING_CATG,-3,1,-1,2 },
{ "msetnx",&xtra[273],0xf8258510,MSETNX_CMD,CMD_WRITE_FLAG,6,STRING_CATG,-3,1,-1,2 },
{ "psetex",&xtra[278],0xac199a7e,PSETEX_CMD,CMD_WRITE_FLAG,6,STRING_CATG,4,1,1,1 },
{ "set",&xtra[283],0xa48d1b18,SET_CMD,CMD_WRITE_FLAG,3,STRING_CATG,-3,1,1,1 },
{ "setbit",&xtra[288],0x8c0fac33,SETBIT_CMD,CMD_WRITE_FLAG,6,STRING_CATG,4,1,1,1 },
{ "setex",&xtra[293],0x52c54753,SETEX_CMD,CMD_WRITE_FLAG,5,STRING_CATG,4,1,1,1 },
{ "setnx",&xtra[298],0xfb362c72,SETNX_CMD,CMD_WRITE_FLAG,5,STRING_CATG,3,1,1,1 },
{ "setrange",&xtra[303],0x14ab59f5,SETRANGE_CMD,CMD_WRITE_FLAG,8,STRING_CATG,4,1,1,1 },
{ "strlen",&xtra[308],0xbebb35df,STRLEN_CMD,CMD_READ_FLAG,6,STRING_CATG,2,1,1,1 },
{ "blpop",&xtra[313],0x60a18ff1,BLPOP_CMD,CMD_WRITE_FLAG,5,LIST_CATG,-3,1,-2,1 },
{ "brpop",&xtra[318],0xbbc44f58,BRPOP_CMD,CMD_WRITE_FLAG,5,LIST_CATG,-3,1,-2,1 },
{ "brpoplpush",&xtra[323],0x1a6a74f1,BRPOPLPUSH_CMD,CMD_WRITE_FLAG,10,LIST_CATG,4,1,2,1 },
{ "lindex",&xtra[328],0x6045a767,LINDEX_CMD,CMD_READ_FLAG,6,LIST_CATG,3,1,1,1 },
{ "linsert",&xtra[333],0x69e60543,LINSERT_CMD,CMD_WRITE_FLAG,7,LIST_CATG,5,1,1,1 },
{ "llen",&xtra[338],0xc0771f7c,LLEN_CMD,CMD_READ_FLAG,4,LIST_CATG,2,1,1,1 },
{ "lpop",&xtra[343],0x102d7337,LPOP_CMD,CMD_WRITE_FLAG,4,LIST_CATG,2,1,1,1 },
{ "lpush",&xtra[348],0x1ce0fc81,LPUSH_CMD,CMD_WRITE_FLAG,5,LIST_CATG,-3,1,1,1 },
{ "lpushx",&xtra[353],0xab7dda9b,LPUSHX_CMD,CMD_WRITE_FLAG,6,LIST_CATG,-3,1,1,1 },
{ "lrange",&xtra[358],0x727a7167,LRANGE_CMD,CMD_READ_FLAG,6,LIST_CATG,4,1,1,1 },
{ "lrem",&xtra[363],0x4a6559d0,LREM_CMD,CMD_WRITE_FLAG,4,LIST_CATG,4,1,1,1 },
{ "lset",&xtra[368],0x87c8d70d,LSET_CMD,CMD_WRITE_FLAG,4,LIST_CATG,4,1,1,1 },
{ "ltrim",&xtra[373],0xa357bfd0,LTRIM_CMD,CMD_WRITE_FLAG,5,LIST_CATG,4,1,1,1 },
{ "rpop",&xtra[378],0xcb48b39e,RPOP_CMD,CMD_WRITE_FLAG,4,LIST_CATG,2,1,1,1 },
{ "rpoplpush",&xtra[383],0xb2ef28b,RPOPLPUSH_CMD,CMD_WRITE_FLAG,9,LIST_CATG,3,1,2,1 },
{ "rpush",&xtra[388],0xc6c2f72b,RPUSH_CMD,CMD_WRITE_FLAG,5,LIST_CATG,-3,1,1,1 },
{ "rpushx",&xtra[393],0x620e650e,RPUSHX_CMD,CMD_WRITE_FLAG,6,LIST_CATG,-3,1,1,1 },
{ "happend",&xtra[398],0xe805ce94,HAPPEND_CMD,CMD_WRITE_FLAG,7,HASH_CATG,-4,1,1,1 },
{ "hdel",&xtra[403],0x623f60bd,HDEL_CMD,CMD_WRITE_FLAG,4,HASH_CATG,-3,1,1,1 },
{ "hexists",&xtra[408],0xbde1a0df,HEXISTS_CMD,CMD_READ_FLAG,7,HASH_CATG,3,1,1,1 },
{ "hget",&xtra[413],0x12963f6e,HGET_CMD,CMD_READ_FLAG,4,HASH_CATG,3,1,1,1 },
{ "hgetall",&xtra[418],0x9e6a1427,HGETALL_CMD,CMD_READ_FLAG,7,HASH_CATG,2,1,1,1 },
{ "hincrby",&xtra[423],0xa1ddd51e,HINCRBY_CMD,CMD_WRITE_FLAG,7,HASH_CATG,4,1,1,1 },
{ "hincrbyfloat",&xtra[428],0xb4db7b47,HINCRBYFLOAT_CMD,CMD_WRITE_FLAG,12,HASH_CATG,4,1,1,1 },
{ "hkeys",&xtra[433],0xc283fb5b,HKEYS_CMD,CMD_READ_FLAG,5,HASH_CATG,2,1,1,1 },
{ "hlen",&xtra[438],0xbb552e8f,HLEN_CMD,CMD_READ_FLAG,4,HASH_CATG,2,1,1,1 },
{ "hmget",&xtra[443],0x71388c2a,HMGET_CMD,CMD_READ_FLAG,5,HASH_CATG,-3,1,1,1 },
{ "hmset",&xtra[448],0x9f4455ba,HMSET_CMD,CMD_WRITE_FLAG,5,HASH_CATG,-4,1,1,1 },
{ "hset",&xtra[453],0xfceae6fe,HSET_CMD,CMD_WRITE_FLAG,4,HASH_CATG,-4,1,1,1 },
{ "hsetnx",&xtra[458],0xa5e0d97e,HSETNX_CMD,CMD_WRITE_FLAG,6,HASH_CATG,4,1,1,1 },
{ "hstrlen",&xtra[463],0xf3a62cfa,HSTRLEN_CMD,CMD_READ_FLAG,7,HASH_CATG,3,1,1,1 },
{ "hvals",&xtra[468],0x87f71efb,HVALS_CMD,CMD_READ_FLAG,5,HASH_CATG,2,1,1,1 },
{ "hscan",&xtra[473],0x1b56612,HSCAN_CMD,CMD_READ_FLAG,5,HASH_CATG,-3,1,1,1 },
{ "sadd",&xtra[478],0xbdd9cd83,SADD_CMD,CMD_WRITE_FLAG,4,SET_CATG,-3,1,1,1 },
{ "scard",&xtra[483],0xc5082eb4,SCARD_CMD,CMD_READ_FLAG,5,SET_CATG,2,1,1,1 },
{ "sdiff",&xtra[488],0x742d4811,SDIFF_CMD,CMD_READ_FLAG,5,SET_CATG,-2,1,-1,1 },
{ "sdiffstore",&xtra[493],0x28f1c48e,SDIFFSTORE_CMD,CMD_WRITE_FLAG,10,SET_CATG,-3,1,-1,1 },
{ "sinter",&xtra[498],0x5d462659,SINTER_CMD,CMD_READ_FLAG,6,SET_CATG,-2,1,-1,1 },
{ "sinterstore",&xtra[503],0x9126a2ff,SINTERSTORE_CMD,CMD_WRITE_FLAG,11,SET_CATG,-3,1,-1,1 },
{ "sismember",&xtra[508],0x97ed994b,SISMEMBER_CMD,CMD_READ_FLAG,9,SET_CATG,3,1,1,1 },
{ "smembers",&xtra[513],0x73c6c4a5,SMEMBERS_CMD,CMD_READ_FLAG,8,SET_CATG,2,1,1,1 },
{ "smove",&xtra[518],0xa208752d,SMOVE_CMD,CMD_WRITE_FLAG,5,SET_CATG,4,1,2,1 },
{ "spop",&xtra[523],0x160d1926,SPOP_CMD,CMD_WRITE_FLAG,4,SET_CATG,-2,1,1,1 },
{ "srandmember",&xtra[528],0x38ebbda3,SRANDMEMBER_CMD,CMD_READ_FLAG,11,SET_CATG,-2,1,1,1 },
{ "srem",&xtra[533],0x4c4533c1,SREM_CMD,CMD_WRITE_FLAG,4,SET_CATG,-3,1,1,1 },
{ "sunion",&xtra[538],0x63667c69,SUNION_CMD,CMD_READ_FLAG,6,SET_CATG,-2,1,-1,1 },
{ "sunionstore",&xtra[543],0x5b9ca3db,SUNIONSTORE_CMD,CMD_WRITE_FLAG,11,SET_CATG,-3,1,-1,1 },
{ "sscan",&xtra[548],0x3c3bca4,SSCAN_CMD,CMD_READ_FLAG,5,SET_CATG,-3,1,1,1 },
{ "zadd",&xtra[553],0x96d804dd,ZADD_CMD,CMD_WRITE_FLAG,4,SORTED_SET_CATG,-4,1,1,1 },
{ "zcard",&xtra[558],0x387e4a89,ZCARD_CMD,CMD_READ_FLAG,5,SORTED_SET_CATG,2,1,1,1 },
{ "zcount",&xtra[563],0x90633599,ZCOUNT_CMD,CMD_READ_FLAG,6,SORTED_SET_CATG,4,1,1,1 },
{ "zincrby",&xtra[568],0xed807628,ZINCRBY_CMD,CMD_WRITE_FLAG,7,SORTED_SET_CATG,4,1,1,1 },
{ "zinterstore",&xtra[573],0xaa6930f2,ZINTERSTORE_CMD,CMD_WRITE_MV_FLAG,11,SORTED_SET_CATG,-4,1,1,1 },
{ "zlexcount",&xtra[578],0x63f59f2a,ZLEXCOUNT_CMD,CMD_READ_FLAG,9,SORTED_SET_CATG,4,1,1,1 },
{ "zrange",&xtra[583],0xdb0fd6ed,ZRANGE_CMD,CMD_READ_FLAG,6,SORTED_SET_CATG,-4,1,1,1 },
{ "zrangebylex",&xtra[588],0x63952c89,ZRANGEBYLEX_CMD,CMD_READ_FLAG,11,SORTED_SET_CATG,-4,1,1,1 },
{ "zrevrangebylex",&xtra[593],0xb4c98dd2,ZREVRANGEBYLEX_CMD,CMD_READ_FLAG,14,SORTED_SET_CATG,-4,1,1,1 },
{ "zrangebyscore",&xtra[598],0xa9b2e2f1,ZRANGEBYSCORE_CMD,CMD_READ_FLAG,13,SORTED_SET_CATG,-4,1,1,1 },
{ "zrank",&xtra[603],0xbe173ecd,ZRANK_CMD,CMD_READ_FLAG,5,SORTED_SET_CATG,3,1,1,1 },
{ "zrem",&xtra[608],0x6744fa9f,ZREM_CMD,CMD_WRITE_FLAG,4,SORTED_SET_CATG,-3,1,1,1 },
{ "zremrangebylex",&xtra[613],0xf9193bc5,ZREMRANGEBYLEX_CMD,CMD_WRITE_FLAG,14,SORTED_SET_CATG,4,1,1,1 },
{ "zremrangebyrank",&xtra[618],0x3dc65964,ZREMRANGEBYRANK_CMD,CMD_WRITE_FLAG,15,SORTED_SET_CATG,4,1,1,1 },
{ "zremrangebyscore",&xtra[623],0x41afbf99,ZREMRANGEBYSCORE_CMD,CMD_WRITE_FLAG,16,SORTED_SET_CATG,4,1,1,1 },
{ "zrevrange",&xtra[628],0x54ce86b8,ZREVRANGE_CMD,CMD_READ_FLAG,9,SORTED_SET_CATG,-4,1,1,1 },
{ "zrevrangebyscore",&xtra[633],0x90b35fac,ZREVRANGEBYSCORE_CMD,CMD_READ_FLAG,16,SORTED_SET_CATG,-4,1,1,1 },
{ "zrevrank",&xtra[638],0xb44209f0,ZREVRANK_CMD,CMD_READ_FLAG,8,SORTED_SET_CATG,3,1,1,1 },
{ "zscore",&xtra[643],0x9bd50094,ZSCORE_CMD,CMD_READ_FLAG,6,SORTED_SET_CATG,3,1,1,1 },
{ "zunionstore",&xtra[648],0x60d331d6,ZUNIONSTORE_CMD,CMD_WRITE_MV_FLAG,11,SORTED_SET_CATG,-4,1,1,1 },
{ "zscan",&xtra[653],0xfeb5d899,ZSCAN_CMD,CMD_READ_FLAG,5,SORTED_SET_CATG,-3,1,1,1 },
{ "zpopmin",&xtra[658],0x40898d3b,ZPOPMIN_CMD,CMD_WRITE_FLAG,7,SORTED_SET_CATG,-2,1,1,1 },
{ "zpopmax",&xtra[663],0xeb626e04,ZPOPMAX_CMD,CMD_WRITE_FLAG,7,SORTED_SET_CATG,-2,1,1,1 },
{ "bzpopmin",&xtra[668],0x85cbf474,BZPOPMIN_CMD,CMD_WRITE_FLAG,8,SORTED_SET_CATG,-3,1,-2,1 },
{ "bzpopmax",&xtra[673],0x2e20174b,BZPOPMAX_CMD,CMD_WRITE_FLAG,8,SORTED_SET_CATG,-3,1,-2,1 },
{ "geoadd",&xtra[678],0xb9b8cd97,GEOADD_CMD,CMD_WRITE_FLAG,6,GEO_CATG,-5,1,1,1 },
{ "geohash",&xtra[682],0xd84fa2bc,GEOHASH_CMD,CMD_READ_FLAG,7,GEO_CATG,-2,1,1,1 },
{ "geopos",&xtra[686],0x13ceac6,GEOPOS_CMD,CMD_READ_FLAG,6,GEO_CATG,-2,1,1,1 },
{ "geodist",&xtra[690],0x3065c6d3,GEODIST_CMD,CMD_READ_FLAG,7,GEO_CATG,-4,1,1,1 },
{ "georadius",&xtra[694],0xda4fa362,GEORADIUS_CMD,CMD_WRITE_MV_FLAG,9,GEO_CATG,-6,1,1,1 },
{ "georadiusbymember",&xtra[698],0x8b414043,GEORADIUSBYMEMBER_CMD,CMD_WRITE_MV_FLAG,17,GEO_CATG,-5,1,1,1 },
{ "pfadd",&xtra[702],0x7d56a5b8,PFADD_CMD,CMD_WRITE_FLAG,5,HYPERLOGLOG_CATG,-2,1,1,1 },
{ "pfcount",&xtra[707],0x1df7341f,PFCOUNT_CMD,CMD_READ_FLAG,7,HYPERLOGLOG_CATG,-2,1,-1,1 },
{ "pfmerge",&xtra[712],0x19a765cb,PFMERGE_CMD,CMD_WRITE_FLAG,7,HYPERLOGLOG_CATG,-2,1,-1,1 },
{ "psubscribe",&xtra[717],0xb8e631e0,PSUBSCRIBE_CMD,CMD_NOFLAGS,10,PUBSUB_CATG,-2,0,0,0 },
{ "pubsub",&xtra[722],0x15f739e3,PUBSUB_CMD,CMD_NOFLAGS,6,PUBSUB_CATG,-2,0,0,0 },
{ "publish",&xtra[730],0xc7bd0d16,PUBLISH_CMD,CMD_NOFLAGS,7,PUBSUB_CATG,3,0,0,0 },
{ "punsubscribe",&xtra[735],0xb4abbb36,PUNSUBSCRIBE_CMD,CMD_NOFLAGS,12,PUBSUB_CATG,-1,0,0,0 },
{ "subscribe",&xtra[740],0xb757e03d,SUBSCRIBE_CMD,CMD_NOFLAGS,9,PUBSUB_CATG,-2,0,0,0 },
{ "unsubscribe",&xtra[745],0x6e3e2140,UNSUBSCRIBE_CMD,CMD_NOFLAGS,11,PUBSUB_CATG,-1,0,0,0 },
{ "discard",&xtra[750],0xd23e9106,DISCARD_CMD,CMD_NOFLAGS,7,TRANSACTION_CATG,1,0,0,0 },
{ "exec",&xtra[755],0xba224361,EXEC_CMD,CMD_NOFLAGS,4,TRANSACTION_CATG,1,0,0,0 },
{ "multi",&xtra[760],0xe7229311,MULTI_CMD,CMD_NOFLAGS,5,TRANSACTION_CATG,1,0,0,0 },
{ "unwatch",&xtra[765],0xd514cb3c,UNWATCH_CMD,CMD_NOFLAGS,7,TRANSACTION_CATG,1,0,0,0 },
{ "watch",&xtra[770],0xb0335e4d,WATCH_CMD,CMD_READ_FLAG,5,TRANSACTION_CATG,-2,1,-1,1 },
{ "xinfo",&xtra[775],0xa518b47c,XINFO_CMD,CMD_READ_FLAG,5,STREAM_CATG,-2,2,2,1 },
{ "xadd",&xtra[785],0x29bf275c,XADD_CMD,CMD_WRITE_FLAG,4,STREAM_CATG,-5,1,1,1 },
{ "xtrim",&xtra[790],0xcc3060b3,XTRIM_CMD,CMD_WRITE_FLAG,5,STREAM_CATG,-2,1,1,1 },
{ "xdel",&xtra[795],0x8b5bd180,XDEL_CMD,CMD_WRITE_FLAG,4,STREAM_CATG,-2,1,1,1 },
{ "xrange",&xtra[800],0x83762e,XRANGE_CMD,CMD_READ_FLAG,6,STREAM_CATG,-4,1,1,1 },
{ "xrevrange",&xtra[805],0xb95f5cd9,XREVRANGE_CMD,CMD_READ_FLAG,9,STREAM_CATG,-4,1,1,1 },
{ "xlen",&xtra[810],0x52319fb2,XLEN_CMD,CMD_READ_FLAG,4,STREAM_CATG,2,1,1,1 },
{ "xread",&xtra[815],0xe9817356,XREAD_CMD,CMD_READ_MV_FLAG,5,STREAM_CATG,-3,1,1,1 },
{ "xgroup",&xtra[820],0x44dd7e87,XGROUP_CMD,CMD_WRITE_FLAG,6,STREAM_CATG,-2,2,2,1 },
{ "xreadgroup",&xtra[831],0x21c71fc9,XREADGROUP_CMD,CMD_WRITE_MV_FLAG,10,STREAM_CATG,-3,1,1,1 },
{ "xack",&xtra[836],0xdc1d23d,XACK_CMD,CMD_WRITE_FLAG,4,STREAM_CATG,-4,1,1,1 },
{ "xclaim",&xtra[841],0xd5301015,XCLAIM_CMD,CMD_WRITE_FLAG,6,STREAM_CATG,-5,1,1,1 },
{ "xpending",&xtra[846],0xe44a9236,XPENDING_CMD,CMD_READ_FLAG,8,STREAM_CATG,-3,1,1,1 },
{ "xsetid",&xtra[851],0x429c28ba,XSETID_CMD,CMD_WRITE_FLAG,6,STREAM_CATG,4,1,1,1 }
};

#ifdef REDIS_XTRA
const RedisCmdExtra xtra[ 856 ] = {
{ &xtra[1], XTRA_SHORT, "echo string"},
{ &xtra[2], XTRA_USAGE, "echo string\n"},
{ &xtra[3], XTRA_EXAMPLE, "> echo hello\n"
"\"hello\"\n"},
{ &xtra[4], XTRA_DESCR, "Echo the string.\n"},
{ NULL, XTRA_RETURN, "The string is sent back.\n"},
{ &xtra[6], XTRA_SHORT, "reply with pong"},
{ &xtra[7], XTRA_USAGE, "ping [string]\n"},
{ &xtra[8], XTRA_EXAMPLE, "> ping\n"
"'PONG'\n"
"> ping hello\n"
"\"hello\"\n"},
{ &xtra[9], XTRA_DESCR,
"Ping sends PONG when used without a string.  Reply with the string\n"
"when it is present.\n"},
{ NULL, XTRA_RETURN, "Either PONG or the string.\n"},
{ &xtra[11], XTRA_SHORT, "close connection"},
{ &xtra[12], XTRA_USAGE, "quit\n"},
{ &xtra[13], XTRA_EXAMPLE, "> quit\n"
"'OK'\n"
"(connection closed)\n"},
{ &xtra[14], XTRA_DESCR, "Close the connection.\n"},
{ NULL, XTRA_RETURN,
"An *OK* is returned, then the connection is closed.\n"},
{ &xtra[16], XTRA_SHORT, "choose db"},
{ &xtra[17], XTRA_USAGE, "select db\n"},
{ &xtra[18], XTRA_DESCR,
"Change the working database to db, where db is a number between 0 and\n"
"255.\n"},
{ NULL, XTRA_RETURN, "*OK* or range or parse error.\n"},
{ &xtra[20], XTRA_SHORT, "query connected clients"},
{ &xtra[21], XTRA_USAGE,
"client [setname name | getname | id | kill match | list match |\n"
"        reply state]\n"},
{ &xtra[22], XTRA_EXAMPLE, "> client setname AAA\n"
"'OK'\n"},
{ &xtra[23], XTRA_DESCR, "Set the current connection name.\n"},
{ &xtra[24], XTRA_EXAMPLE, "> client getname\n"
"\"AAA\"\n"},
{ &xtra[25], XTRA_DESCR, "Get the current connection name.\n"},
{ &xtra[26], XTRA_EXAMPLE, "> client id\n"
"12\n"},
{ &xtra[27], XTRA_DESCR, "Get the current connection id.\n"},
{ &xtra[28], XTRA_EXAMPLE,
"> client list type tcp\n"
"id=12 addr=[::1]:58806 fd=14 name=AAA kind=redis age=150 idle=0 rbuf=0 \n"
"  rsz=16384 imsg=7 br=257 wbuf=0 wsz=5120 omsg=6 bs=1082 flags=N db=0 \n"
"  sub=0 psub=0 multi=-1 cmd=client\n"
"id=13 addr=[::1]:58808 fd=15 name= kind=redis age=74 idle=74 rbuf=0 \n"
"  rsz=16384 imsg=0 br=0 wbuf=0 wsz=5120 omsg=0 bs=0 flags=N db=0 \n"
"  sub=0 psub=0 multi=-1 cmd=none\n"},
{ &xtra[29], XTRA_DESCR,
"List the clients.  The filters that match the clients which are listed\n"
"are:\n"
"\n"
"- type [ tcp | udp | unix | listen | redis | pubsub | normal | http ] --\n"
"  filter by connection class.\n"
"- id N -- filter by id number\n"
"- addr IP -- filter by IP address\n"
"- skipme -- skip the current connection\n"},
{ &xtra[30], XTRA_EXAMPLE,
"> client kill id 13\n"
"1\n"
"> client kill type redis skipme\n"
"0\n"},
{ &xtra[31], XTRA_DESCR,
"Kill clients.  The filters that match the clients which are listed the\n"
"same as the filters that list.\n"},
{ &xtra[32], XTRA_EXAMPLE,
"> client reply skip\n"
"> ping\n"
"> ping\n"
"'PONG'\n"
"> client reply off\n"
"> ping\n"
"> client reply on\n"
"'OK'\n"
"> ping\n"
"'PONG'\n"},
{ NULL, XTRA_DESCR,
"Alter the reply behavior of the connection.  If skipped or off, output\n"
"will be muted.\n"},
{ &xtra[34], XTRA_SHORT, "query command info"},
{ &xtra[35], XTRA_USAGE,
"command [count | getkeys <cmd-full> | info [cmd] | help]\n"},
{ &xtra[36], XTRA_EXAMPLE,
"> command info get\n"
"[[\"get\",2,['readonly','fast'],1,1,1]]\n"
"> command count\n"
"193\n"
"> command help get\n"
"['GET','key ; Get value']\n"},
{ &xtra[37], XTRA_DESCR, "Get command details and help.\n"},
{ NULL, XTRA_RETURN, "Array of strings, command info.\n"},
{ &xtra[39], XTRA_SHORT, "query config"},
{ &xtra[40], XTRA_USAGE,
"config [get <param> | rewrite | set <param> <value> | resetstat]\n"},
{ &xtra[41], XTRA_DESCR,
"Get, set config parameters.  There is no configuration, so these\n"
"are not functional except get, which returns sane values.\n"},
{ NULL, XTRA_RETURN, "Array of config key values.\n"},
{ &xtra[43], XTRA_SHORT, "get number of keys"},
{ &xtra[44], XTRA_USAGE, "dbsize \n"},
{ &xtra[45], XTRA_EXAMPLE, "> dbsize\n"
"299999\n"},
{ &xtra[46], XTRA_DESCR, "Get number of keys in db.\n"},
{ NULL, XTRA_RETURN, "An integer number of keys.\n"},
{ &xtra[48], XTRA_SHORT, "run debug"},
{ &xtra[49], XTRA_USAGE, "debug [object key | htstats]\n"},
{ &xtra[50], XTRA_EXAMPLE,
"> set hello world\n"
"'OK'\n"
"> debug object hello\n"
"key:         \"hello\"\n"
"hash:        2aa73a1eeb0b2d45:fd102121185ce157\n"
"pos:         [732172]+0.0\n"
"update_time: -4s\n"
"flags:       string-Upd-Ival-Key-Stmp\n"
"db:          0\n"
"val:         0\n"
"seqno:       3\n"
"size:        5\n"},
{ &xtra[51], XTRA_DESCR, "Get debug info about key.\n"},
{ &xtra[52], XTRA_EXAMPLE,
"> debug htstats\n"
"db_num:  0\n"
"\n"
"-= totals =-\n"
"read:    8896064\n"
"write:   2045184\n"
"spins:   0\n"
"chains:  0\n"
"add:     303\n"
"drop:    2\n"
"expire:  0\n"
"htevict: 0\n"
"afail:   0\n"
"hit:     511040\n"
"miss:    0\n"
"cuckacq: 0\n"
"cuckfet: 0\n"
"cuckmov: 0\n"
"cuckret: 0\n"
"cuckmax: 0\n"
"\n"
"-= self =-\n"
"read:    8896064\n"
"write:   2045184\n"
"spins:   0\n"
"chains:  0\n"
"add:     303\n"
"drop:    2\n"
"expire:  0\n"
"htevict: 0\n"
"afail:   0\n"
"hit:     511040\n"
"miss:    0\n"
"cuckacq: 0\n"
"cuckfet: 0\n"
"cuckmov: 0\n"
"cuckret: 0\n"
"cuckmax: 0\n"},
{ &xtra[53], XTRA_DESCR,
"Get information about the hash table counters.\n"},
{ NULL, XTRA_RETURN,
"A string description of debug info or bad command error.\n"},
{ &xtra[55], XTRA_SHORT, "remove keys"},
{ &xtra[56], XTRA_USAGE, "flushall [async]\n"},
{ &xtra[57], XTRA_DESCR, "Remove keys from all dbs.\n"},
{ NULL, XTRA_RETURN, "*OK* if successful, error otherwise.\n"},
{ &xtra[59], XTRA_SHORT, "remove keys from db"},
{ &xtra[60], XTRA_USAGE, "flushdb [async]\n"},
{ &xtra[61], XTRA_DESCR, "Remove keys from selected db\n"},
{ NULL, XTRA_RETURN, "*OK* if successful, error otherwise.\n"},
{ &xtra[63], XTRA_SHORT, "query server stats"},
{ &xtra[64], XTRA_USAGE,
"info [server | clients | memory | persistence | stats |\n"
"      replication | cpu | commandstats | cluster | keyspace]\n"},
{ &xtra[65], XTRA_EXAMPLE,
"> info server\n"
"raids_version:        1.0.0-11\n"
"raids_git:            fee49cdd\n"
"gcc_version:          9.1.1\n"
"process_id:           32167\n"
"> info clients\n"
"redis_clients:        1\n"
"pubsub_clients:       0\n"
"> info memory\n"
"vm_peak:              8204MB\n"
"vm_size:              8204MB\n"
"> info stats\n"
"ht_operations:        505M\n"
"ht_chains:            1.0\n"
"ht_read:              505M\n"
"ht_write:             287\n"
"> info cpu\n"
"used_cpu_sys:         0.069951\n"
"used_cpu_user:        1.445196\n"
"used_cpu_total:       1.515147\n"},
{ &xtra[66], XTRA_DESCR, "Get version info and counters.\n"},
{ NULL, XTRA_RETURN,
"A text string with newlines that has the requested info.\n"},
{ &xtra[68], XTRA_SHORT, "monitor commands"},
{ &xtra[69], XTRA_USAGE, "monitor \n"},
{ &xtra[70], XTRA_EXAMPLE,
"> monitor\n"
"[\"pmessage\",\"__monitor_@*\",\"__monitor_@0__:127.0.0.1:60646\",\n"
"[[\"get\",\"k\"],\"value\",\"1580125101.975300\"]]\n"},
{ &xtra[71], XTRA_DESCR,
"Monitor commands executed by server from all clients.  This is an\n"
"alias for `psubscribe _monitor_@*`.  Running once enables, running\n"
"twice disables the monitor.  In order to monitor just one client, or\n"
"just one ip address, use a pattern that includes the address:\n"
"`psubscribe _monitor_@0__:127.0.0.1*`\n"},
{ NULL, XTRA_RETURN,
"An array which indicates the db number and client connected address\n"
"(`\"__monitor_@0__:127.0.0.1:60646\"`), the command executed\n"
"(`[\"get\",\"k\"]`), and the result of executing the command (`\"value\"`).\n"},
{ &xtra[73], XTRA_SHORT, "sync save"},
{ &xtra[74], XTRA_USAGE, "save \n"},
{ &xtra[75], XTRA_DESCR, "Synchronously save to rdb format file.\n"},
{ NULL, XTRA_RETURN, "*OK* or error if save fails.\n"},
{ &xtra[77], XTRA_SHORT, "sync load"},
{ &xtra[78], XTRA_USAGE, "load\n"},
{ &xtra[79], XTRA_DESCR, "Synchronously load from rdb format file.\n"},
{ NULL, XTRA_RETURN, "*OK* or error if load fails.\n"},
{ &xtra[81], XTRA_SHORT, "shutdown server"},
{ &xtra[82], XTRA_USAGE, "shutdown\n"},
{ NULL, XTRA_DESCR,
"Shutdown server.  This will cause the connected instance to quit.\n"},
{ &xtra[84], XTRA_SHORT, "get server time"},
{ &xtra[85], XTRA_USAGE, "time \n"},
{ &xtra[86], XTRA_EXAMPLE, "> time\n"
"[\"1580125969\",\"562228\"]\n"},
{ &xtra[87], XTRA_DESCR, "Get server time.\n"},
{ NULL, XTRA_RETURN,
"An array, UTC seconds and microseconds (1 usec = 1/1000000 second).\n"},
{ &xtra[89], XTRA_SHORT, "delete keys"},
{ &xtra[90], XTRA_USAGE, "del key [key ...]\n"},
{ &xtra[91], XTRA_EXAMPLE, "> del h hl hl2 hl3\n"
"4\n"},
{ &xtra[92], XTRA_DESCR, "Delete one or more keys.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of keys deleted is returned.\n"},
{ &xtra[94], XTRA_SHORT, "dump key"},
{ &xtra[95], XTRA_USAGE, "dump key\n"},
{ &xtra[96], XTRA_EXAMPLE,
"> set k sophisticateduniverse\n"
"'OK'\n"
"> dump k\n"
"\"\\u0000\\u0021sophisticateduniverse\\t\\u0000!y0\\u00022ZD\\u0163\"\n"},
{ &xtra[97], XTRA_DESCR, "Serialize value at key.\n"},
{ NULL, XTRA_RETURN,
"The binary value of the key slot as a bulk string or *nil* when key\n"
"does not exist.\n"},
{ &xtra[99], XTRA_SHORT, "test if key exists"},
{ &xtra[100], XTRA_USAGE, "exists key [key ...]\n"},
{ &xtra[101], XTRA_EXAMPLE, "> exists k l m\n"
"3\n"},
{ &xtra[102], XTRA_DESCR, "Test if one or more keys exists.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of keys that exist.\n"},
{ &xtra[104], XTRA_SHORT, "set key expire secs"},
{ &xtra[105], XTRA_USAGE, "expire key secs\n"},
{ &xtra[106], XTRA_EXAMPLE, "> expire k 10\n"
"1\n"},
{ &xtra[107], XTRA_DESCR, "Set expire seconds.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* if key expire time was set, *0* if not.\n"},
{ &xtra[109], XTRA_SHORT, "set key expire utc"},
{ &xtra[110], XTRA_USAGE, "expireat key stamp\n"},
{ &xtra[111], XTRA_EXAMPLE, "> expireat k 1580076128\n"
"1\n"
"> ttl k\n"
"67\n"},
{ &xtra[112], XTRA_DESCR, "Set expire at time.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* if key expire time was set, *0* if not.\n"},
{ &xtra[114], XTRA_SHORT, "get keys matching pattern"},
{ &xtra[115], XTRA_USAGE, "keys pattern\n"},
{ &xtra[116], XTRA_EXAMPLE, "> keys k*\n"
"[\"k\",\"kkk\",\"kk\"]\n"},
{ &xtra[117], XTRA_DESCR, "Find all keys matching pattern.\n"},
{ NULL, XTRA_RETURN,
"An array of key strings that match the pattern.\n"},
{ &xtra[119], XTRA_SHORT, "inspect key"},
{ &xtra[120], XTRA_USAGE,
"object [refcount key | encoding key | idletime key | freq key | help]\n"},
{ &xtra[121], XTRA_EXAMPLE,
"> object freq k\n"
"nil\n"
"> set k hello\n"
"'OK'\n"
"> object freq k\n"
"0\n"
"> set k world\n"
"'OK'\n"
"> object freq k\n"
"1\n"
"> object idletime k\n"
"6\n"
"> object encoding k\n"
"\"string\"\n"},
{ &xtra[122], XTRA_DESCR,
"Inspect key value attributes maintained and stored with the data.\n"},
{ NULL, XTRA_RETURN,
"If key does not exist, then *nil*.  Otherwise an integer value indicating\n"
"one of the following based on the command:\n"
"\n"
"- refcount, valid values are always *1*.\n"
"- encoding, the type of data.\n"
"- idletime, the number seconds since the value was updated.\n"
"- freq, the number of times key was updated.  The inital value resets this to\n"
"  zero, and every subsequent update increments.\n"},
{ &xtra[124], XTRA_SHORT, "clear expire stamp"},
{ &xtra[125], XTRA_USAGE, "persist key\n"},
{ &xtra[126], XTRA_EXAMPLE, "> persist k\n"
"1\n"},
{ &xtra[127], XTRA_DESCR, "Remove expiration time.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* if key exists was cleared, *0* if not.\n"},
{ &xtra[129], XTRA_SHORT, "set expire millisecs"},
{ &xtra[130], XTRA_USAGE, "pexpire key ms\n"},
{ &xtra[131], XTRA_EXAMPLE, "> pexpire k 10000\n"
"1\n"
"> ttl k\n"
"7\n"
"> pttl k\n"
"3986\n"},
{ &xtra[132], XTRA_DESCR, "Set expire ttl in milliseconds.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* if key expire time was set, *0* if not.\n"},
{ &xtra[134], XTRA_SHORT, "set expire ms utc"},
{ &xtra[135], XTRA_USAGE, "pexpireat key ms\n"},
{ &xtra[136], XTRA_EXAMPLE,
"> pexpireat k 1580077977700\n"
"1\n"
"> ttl k\n"
"59\n"
"> pttl k\n"
"51395\n"},
{ &xtra[137], XTRA_DESCR, "Set expire at ms stamp.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* if key expire time was set, *0* if not.\n"},
{ &xtra[139], XTRA_SHORT, "get the ms time left"},
{ &xtra[140], XTRA_USAGE, "pttl key\n"},
{ &xtra[141], XTRA_EXAMPLE, "> pttl k\n"
"51395\n"},
{ &xtra[142], XTRA_DESCR, "Get expire time in milliseconds.\n"},
{ NULL, XTRA_RETURN,
"The amount of milliseconds left or *-1* when key doesn't expire, and\n"
"*-2* when key doesn't exist.\n"},
{ &xtra[144], XTRA_SHORT, "get a random key"},
{ &xtra[145], XTRA_USAGE, "randomkey \n"},
{ &xtra[146], XTRA_EXAMPLE, "> randomkey\n"
"\"bf\"\n"
"> randomkey\n"
"\"jjj\"\n"},
{ &xtra[147], XTRA_DESCR, "Get a random key.\n"},
{ NULL, XTRA_RETURN, "A string key, if any exists, *nil* if not.\n"},
{ &xtra[149], XTRA_SHORT, "rename key to new name"},
{ &xtra[150], XTRA_USAGE, "rename key newkey\n"},
{ &xtra[151], XTRA_EXAMPLE, "> rename jjj j\n"
"'OK'\n"},
{ &xtra[152], XTRA_DESCR, "Rename key to a new name.\n"},
{ NULL, XTRA_RETURN, "*OK* when successful, error otherwise.\n"},
{ &xtra[154], XTRA_SHORT, "rename key if not exist"},
{ &xtra[155], XTRA_USAGE, "renamenx key newkey\n"},
{ &xtra[156], XTRA_EXAMPLE, "> renamenx k j\n"
"0\n"
"> del j\n"
"1\n"
"> renamenx k j\n"
"1\n"},
{ &xtra[157], XTRA_DESCR, "Rename key if new key doesn't exists.\n"},
{ NULL, XTRA_RETURN,
"An integer *1* if success, *0* if not, error if key doesn't exist.\n"},
{ &xtra[159], XTRA_SHORT, "restore key from dump"},
{ &xtra[160], XTRA_USAGE,
"restore key ttl value [replace] [absttl] [idletime idle] [freq lfu]\n"},
{ &xtra[161], XTRA_DESCR,
"Restore key using dump format.  The value argument is in a specific binary\n"
"format that is constructed by the dump command, which has a version and a crc\n"
"checksum attached (not easily constructed without a program).\n"},
{ NULL, XTRA_RETURN, "*OK* when successful, error otherwise.\n"},
{ &xtra[163], XTRA_SHORT, "set last access time"},
{ &xtra[164], XTRA_USAGE, "touch key [key ...]\n"},
{ &xtra[165], XTRA_EXAMPLE, "> touch j\n"
"1\n"
"> object idletime j\n"
"4\n"},
{ &xtra[166], XTRA_DESCR, "Set update time of key.\n"},
{ NULL, XTRA_RETURN, "An integer *1* if success, *0* if not.\n"},
{ &xtra[168], XTRA_SHORT, "get ttl secs"},
{ &xtra[169], XTRA_USAGE, "ttl key\n"},
{ &xtra[170], XTRA_EXAMPLE, "> ttl j\n"
"-1\n"
"> expire j 100\n"
"1\n"
"> ttl j\n"
"98\n"},
{ &xtra[171], XTRA_DESCR, "Get expire time in seconds.\n"},
{ NULL, XTRA_RETURN,
"The amount of seconds left or *-1* when key doesn't expire, and *-2*\n"
"when key doesn't exist.\n"},
{ &xtra[173], XTRA_SHORT, "get type of key"},
{ &xtra[174], XTRA_USAGE, "type key\n"},
{ &xtra[175], XTRA_EXAMPLE,
"> pfadd hl 1 2 3 4 5 6 10\n"
"1\n"
"> type hl\n"
"'hyperloglog'\n"},
{ &xtra[176], XTRA_DESCR, "Get the type of a key.\n"},
{ NULL, XTRA_RETURN,
"The type of key in a string or the string none.\n"},
{ &xtra[178], XTRA_SHORT, "delete key"},
{ &xtra[179], XTRA_USAGE, "unlink key [key ...]\n"},
{ &xtra[180], XTRA_EXAMPLE, "> unlink j k l m\n"
"2\n"},
{ &xtra[181], XTRA_DESCR, "Non-blocking delete, mark deleted.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of keys deleted is returned.\n"},
{ &xtra[183], XTRA_SHORT, "scan matching keys"},
{ &xtra[184], XTRA_USAGE, "scan curs [match pat] [count int]\n"},
{ &xtra[185], XTRA_EXAMPLE,
"> scan 0 match j* count 1\n"
"[\"18521679\",[\"jjj\"]]\n"
"> scan 18521679 match j* count 1\n"
"[\"25519714\",[\"j\"]]\n"
"> scan 25519714 match j* count 1\n"
"[\"0\",[]]\n"},
{ &xtra[186], XTRA_DESCR,
"Get the keys which match a pattern.  The cursor is the offset into the\n"
"scan where the results will start.  If the cursor is equal to 18521679\n"
"from the example, then the match will start at the 18521679th element\n"
"in the key hash.\n"},
{ NULL, XTRA_RETURN,
"An array within an array.  The outer array is the cursor counter, the\n"
"inner array is the keys matched.\n"},
{ &xtra[188], XTRA_SHORT, "append to value"},
{ &xtra[189], XTRA_USAGE, "append key value\n"},
{ &xtra[190], XTRA_EXAMPLE,
"> append s string\n"
"5\n"
"> append s value\n"
"9\n"
"> get s\n"
"\"stringvalue\"\n"},
{ &xtra[191], XTRA_DESCR, "Append value to key.\n"},
{ NULL, XTRA_RETURN,
"The integer strlen of the key after value appended.\n"},
{ &xtra[193], XTRA_SHORT, "count bits"},
{ &xtra[194], XTRA_USAGE, "bitcount key [start end]\n"},
{ &xtra[195], XTRA_EXAMPLE,
"> set s string\n"
"'OK'\n"
"> bitcount s 0 0\n"
"5\n"
"> bitfield s get u8 0\n"
"115\n"
"> getrange s 0 0\n"
"\"s\"\n"},
{ &xtra[196], XTRA_DESCR,
"Count the bits in string from byte offset start to offset end,\n"
"inclusive.\n"},
{ NULL, XTRA_RETURN,
"An integer count of bits set in the byte range.\n"},
{ &xtra[198], XTRA_SHORT, "manipulate bits"},
{ &xtra[199], XTRA_USAGE,
"bitfield key [get type off] [set type off value]\n"
" [incrby type off incr] [overflow wrap | sat | fail]\n"},
{ &xtra[200], XTRA_EXAMPLE,
"> bitfield bf set u8 0 1 set u8 8 2 set u8 16 3 set u8 24 4\n"
"[0,0,0,0]\n"},
{ &xtra[201], XTRA_DESCR,
"Set integer value at bit offset off as type, where type is signed (iN)\n"
"or unsigned (uN) with bit size *1* through *63*, *64* for signed.\n"},
{ &xtra[202], XTRA_RETURN,
"An array of the integers that existed before setting the new values.\n"},
{ &xtra[203], XTRA_EXAMPLE,
"> bitfield bf get u8 0 get u8 8 get u8 16 get u8 24\n"
"[1,2,3,4]\n"},
{ &xtra[204], XTRA_DESCR,
"Get integer value at bit offset, using signed or unsigned type.\n"},
{ &xtra[205], XTRA_RETURN, "An array of integers that are requested.\n"},
{ &xtra[206], XTRA_EXAMPLE,
"> bitfield bf incrby u8 0 1 incrby u8 8 1 incrby u8 16 1 incrby u8 24 1\n"
"[2,3,4,5]\n"
"> bitfield bf incrby u8 0 255 overflow wrap\n"
"[1]\n"
"> bitfield bf incrby u8 8 255 overflow sat\n"
"[255]\n"
"> bitfield bf incrby u8 16 255 overflow fail\n"
"[nil]\n"},
{ &xtra[207], XTRA_DESCR,
"Increment integer values at bit offsets.  The overflow arument\n"
"modifies the behavior of increment in the case that the result wraps\n"
"around zero.  Wrap is the default, saturate (sat) caps the value at\n"
"the highest and lowest point, fail discards the new value and uses the\n"
"old value, returning *nil*.\n"},
{ NULL, XTRA_RETURN, "An array of the integers after incrementing.\n"},
{ &xtra[209], XTRA_SHORT, "bitwise operator"},
{ &xtra[210], XTRA_USAGE,
"bitop (and | or | xor | not) dest src [src src ...]\n"},
{ &xtra[211], XTRA_EXAMPLE,
"> bitfield i set u8 0 3\n"
"[0]\n"
"> bitfield j set u8 0 1\n"
"[0]\n"
"> bitop xor k j i\n"
"1\n"
"> bitfield k get u8 0\n"
"[2]\n"},
{ &xtra[212], XTRA_DESCR,
"Bitwise store to dest from srcs by performing logical operations on\n"
"each bit.\n"},
{ NULL, XTRA_RETURN,
"The number of bytes stored in dest, which is the minimum size of i and\n"
"j, since the trailing zeros are not stored.\n"},
{ &xtra[214], XTRA_SHORT, "find a bit"},
{ &xtra[215], XTRA_USAGE, "bitpos key bit [start end]\n"},
{ &xtra[216], XTRA_EXAMPLE,
"> bitfield k set u8 0 16\n"
"[0]\n"
"> bitpos k 1 0 1\n"
"4\n"
"> bitpos k 0 0 1\n"
"0\n"},
{ &xtra[217], XTRA_DESCR,
"Find first bit set or clear between start offset and end offset.\n"},
{ NULL, XTRA_RETURN,
"The position of the bit set or clear, or *-1* when not found.\n"},
{ &xtra[219], XTRA_SHORT, "decr by one"},
{ &xtra[220], XTRA_USAGE, "decr key\n"},
{ &xtra[221], XTRA_EXAMPLE, "> set k 10\n"
"'OK'\n"
"> decr k\n"
"9\n"
"> decr k\n"
"8\n"},
{ &xtra[222], XTRA_DESCR, "Decrement integer at key by one.\n"},
{ NULL, XTRA_RETURN,
"The value after decrementing it.  If key is created, then it is\n"
"initialized to *-1*.\n"},
{ &xtra[224], XTRA_SHORT, "decr by integer"},
{ &xtra[225], XTRA_USAGE, "decrby key int\n"},
{ &xtra[226], XTRA_EXAMPLE,
"> set k 10\n"
"'OK'\n"
"> decrby k -1\n"
"11\n"
"> decrby k 10\n"
"1\n"},
{ &xtra[227], XTRA_DESCR,
"Decrement integer at key by the integer argument.\n"},
{ NULL, XTRA_RETURN,
"The value after decrementing it.  If key is created, then it is\n"
"initialized to the negative of the integer argument.\n"},
{ &xtra[229], XTRA_SHORT, "get key value"},
{ &xtra[230], XTRA_USAGE, "get key\n"},
{ &xtra[231], XTRA_EXAMPLE,
"> set k val\n"
"'OK'\n"
"> get k\n"
"\"val\"\n"
"> del k\n"
"1\n"
"> get k\n"
"nil\n"},
{ &xtra[232], XTRA_DESCR, "Get the key value.\n"},
{ NULL, XTRA_RETURN, "The string value or *nil* when not found.\n"},
{ &xtra[234], XTRA_SHORT, "git bit at offset"},
{ &xtra[235], XTRA_USAGE, "getbit key off\n"},
{ &xtra[236], XTRA_EXAMPLE,
"> bitfield k set u8 0 16\n"
"[0]\n"
"> getbit k 0\n"
"0\n"
"> getbit k 3\n"
"0\n"
"> getbit k 4\n"
"1\n"},
{ &xtra[237], XTRA_DESCR,
"Get value at bit offset in the string stored at the key.\n"},
{ NULL, XTRA_RETURN,
"A *1* if the bit is set, a *0* if not set or not found.\n"},
{ &xtra[239], XTRA_SHORT, "get range in string"},
{ &xtra[240], XTRA_USAGE, "getrange key start end\n"},
{ &xtra[241], XTRA_EXAMPLE,
"> set k 0123456789\n"
"'OK'\n"
"> getrange k 3 7\n"
"\"34567\"\n"
"> getrange k 12 13\n"
"\"\"\n"
"> getrange k 7 -3\n"
"\"7\"\n"
"> getrange k 0 -1\n"
"\"0123456789\"\n"},
{ &xtra[242], XTRA_DESCR,
"Get a substring of the string value at key.  Start and/or end may be\n"
"negative to index from the end of the string.\n"},
{ NULL, XTRA_RETURN,
"A string with the characters in the range start to end, inclusive.\n"},
{ &xtra[244], XTRA_SHORT, "swap values"},
{ &xtra[245], XTRA_USAGE, "getset key value\n"},
{ &xtra[246], XTRA_EXAMPLE, "> getset k 2\n"
"nil\n"
"> getset k 3\n"
"\"2\"\n"},
{ &xtra[247], XTRA_DESCR,
"Swap new value with current value and return it.\n"},
{ NULL, XTRA_RETURN,
"The value currently stored with the key, or *nil* if the key is\n"
"created.\n"},
{ &xtra[249], XTRA_SHORT, "incr by one"},
{ &xtra[250], XTRA_USAGE, "incr key\n"},
{ &xtra[251], XTRA_EXAMPLE, "> incr k\n"
"4\n"
"> incr k\n"
"5\n"
"> del k\n"
"1\n"
"> incr k\n"
"1\n"},
{ &xtra[252], XTRA_DESCR, "Increment integer at key by one.\n"},
{ NULL, XTRA_RETURN,
"The value after it is incremented.  If key is created, then it is\n"
"initialized to *1*.\n"},
{ &xtra[254], XTRA_SHORT, "incr by integer"},
{ &xtra[255], XTRA_USAGE, "incrby key int\n"},
{ &xtra[256], XTRA_EXAMPLE,
"> del k\n"
"1\n"
"> incrby k 100\n"
"100\n"
"> incrby k 100\n"
"200\n"},
{ &xtra[257], XTRA_DESCR,
"Increment integer at key by the integer argument.\n"},
{ NULL, XTRA_RETURN,
"The value after it is incremented.  If key is created, then it is\n"
"initialized to the integer argument.\n"},
{ &xtra[259], XTRA_SHORT, "incr by decimal"},
{ &xtra[260], XTRA_USAGE, "incrbyfloat key decimal\n"},
{ &xtra[261], XTRA_EXAMPLE,
"> incrbyfloat n 1.1\n"
"\"1.1\"\n"
"> incrbyfloat n 1.1\n"
"\"2.2\"\n"
"> incrbyfloat n 1.1\n"
"\"3.3\"\n"},
{ &xtra[262], XTRA_DESCR,
"Increment number at key by decimal value.  This uses 128 bit decimal\n"
"arithmetic which has a 34 digit range and an exponent from -6143 to\n"
"+6144.  https://en.wikipedia.org/wiki/Decimal128_floating-point_format\n"},
{ NULL, XTRA_RETURN,
"The number after it is incremented.  If key is created, then it is\n"
"initialized to the decimal argument.\n"},
{ &xtra[264], XTRA_SHORT, "get multiple values"},
{ &xtra[265], XTRA_USAGE, "mget key [key ...]\n"},
{ &xtra[266], XTRA_EXAMPLE,
"> mset j 1 k 2 l 3 m 4\n"
"'OK'\n"
"> mget j k l m mm\n"
"[\"1\",\"2\",\"3\",\"4\",nil]\n"},
{ &xtra[267], XTRA_DESCR, "Get the values of multiple keys.\n"},
{ NULL, XTRA_RETURN,
"An array of values or nil when key doesn't exist or is not a string\n"
"type.\n"},
{ &xtra[269], XTRA_SHORT, "set multiple values"},
{ &xtra[270], XTRA_USAGE, "mset key val [key val ...]\n"},
{ &xtra[271], XTRA_EXAMPLE, "> mset j 1 k 2 l 3 m 4\n"
"'OK'\n"},
{ &xtra[272], XTRA_DESCR, "Set the values of multiple keys.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[274], XTRA_SHORT, "set if not exist"},
{ &xtra[275], XTRA_USAGE, "msetnx key val [key val ...]\n"},
{ &xtra[276], XTRA_EXAMPLE,
"> del j k l m\n"
"4\n"
"> msetnx j 1 k 2 l 3 m 4\n"
"1\n"
"> msetnx j 1 k 2 l 3 m 4\n"
"0\n"},
{ &xtra[277], XTRA_DESCR,
"Set the values of keys if all keys do not exist.\n"},
{ NULL, XTRA_RETURN,
"If all keys are created a *1* is returned, otherwise no kesy are\n"
"created and a *0* is returnd;\n"},
{ &xtra[279], XTRA_SHORT, "set with expiration"},
{ &xtra[280], XTRA_USAGE, "psetex key ms val\n"},
{ &xtra[281], XTRA_EXAMPLE,
"> psetex k 1580166892000 hello\n"
"'OK'\n"
"> ttl k\n"
"80\n"
"> psetex k 15000 hello\n"
"'OK'\n"
"> ttl k\n"
"13\n"
"> pttl k\n"
"11991\n"},
{ &xtra[282], XTRA_DESCR,
"Set the value with expiration of key in milliseconds.  The expiration\n"
"argument is either stamp or relative time.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[284], XTRA_SHORT, "set value"},
{ &xtra[285], XTRA_USAGE, "set key val [ex secs] [px ms] [nx | xx]\n"},
{ &xtra[286], XTRA_EXAMPLE,
"> set k one\n"
"'OK'\n"
"> set k one xx\n"
"'OK'\n"
"> set k one nx\n"
"nil\n"
"> set k one px 15000 xx\n"
"'OK'\n"
"> ttl k\n"
"11\n"
"> pttl k\n"
"4260\n"},
{ &xtra[287], XTRA_DESCR,
"Set the key value optionally with expiration and *nx* or *xx* test.\n"
"The *nx* option tests that the key does not exist before setting.  The\n"
"*xx* tests that the key does exist before setting.\n"},
{ NULL, XTRA_RETURN, "*OK* on success, *nil* when failed.\n"},
{ &xtra[289], XTRA_SHORT, "set bits"},
{ &xtra[290], XTRA_USAGE, "setbit key off 1 | 0\n"},
{ &xtra[291], XTRA_EXAMPLE,
"> setbit k 0 1\n"
"0\n"
"> setbit k 1 1\n"
"0\n"
"> setbit k 1 0\n"
"1\n"
"> getbit k 0\n"
"1\n"
"> getbit k 1\n"
"0\n"},
{ &xtra[292], XTRA_DESCR,
"Swap the value at bit offset in string with the new bit value.\n"},
{ NULL, XTRA_RETURN,
"A *1* or *0* is returned, the previous value held by bit.\n"},
{ &xtra[294], XTRA_SHORT, "set with expiration"},
{ &xtra[295], XTRA_USAGE, "setex key secs val\n"},
{ &xtra[296], XTRA_EXAMPLE,
"> setex k 1580166892 hello\n"
"'OK'\n"
"> ttl k\n"
"80\n"
"> setex k 15 hello\n"
"'OK'\n"
"> ttl k\n"
"13\n"
"> pttl k\n"
"11991\n"},
{ &xtra[297], XTRA_DESCR,
"Set the value with expiration of key in seconds.  The expiration\n"
"argument is either stamp or relative time.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[299], XTRA_SHORT, "set if not exist"},
{ &xtra[300], XTRA_USAGE, "setnx key val\n"},
{ &xtra[301], XTRA_EXAMPLE,
"> del k\n"
"1\n"
"> setnx k value\n"
"'OK'\n"
"> setnx k value\n"
"nil\n"},
{ &xtra[302], XTRA_DESCR, "Set the value if key does not exist.\n"},
{ NULL, XTRA_RETURN,
"*OK* if success, *nil* if key already exists.\n"},
{ &xtra[304], XTRA_SHORT, "set value range"},
{ &xtra[305], XTRA_USAGE, "setrange key off val\n"},
{ &xtra[306], XTRA_EXAMPLE,
"> del k\n"
"1\n"
"> setrange k 5 waterbuffalo\n"
"17\n"
"> get k\n"
"\"\\u0000\\u0000\\u0000\\u0000\\u0000waterbuffalo\"\n"},
{ &xtra[307], XTRA_DESCR,
"Overwrite or create a range in a string stored with the key at the\n"
"offset specified.  The data implicitly created by the setrange is zero\n"
"padded.\n"},
{ NULL, XTRA_RETURN, "The length of key after modification.\n"},
{ &xtra[309], XTRA_SHORT, "get strlen"},
{ &xtra[310], XTRA_USAGE, "strlen key\n"},
{ &xtra[311], XTRA_EXAMPLE,
"> del k\n"
"1\n"
"> setrange k 5 waterbuffalo\n"
"17\n"
"> strlen k\n"
"17\n"
"> get k\n"
"\"\\u0000\\u0000\\u0000\\u0000\\u0000waterbuffalo\"\n"},
{ &xtra[312], XTRA_DESCR,
"Get length of value, which is the maximum extent, not the strlen\n"
"function.\n"},
{ NULL, XTRA_RETURN,
"The length of value, which could be *0* if the key does not exist.\n"},
{ &xtra[314], XTRA_SHORT, "block and lpop list"},
{ &xtra[315], XTRA_USAGE, "blpop key [key ...] timeout\n"},
{ &xtra[316], XTRA_EXAMPLE, "> brpop l m 0\n"
"[\"l\",\"one\"]\n"},
{ &xtra[317], XTRA_DESCR,
"Left pop the list and return the pair of list name and value.  If the\n"
"list is empty, block and wait for timeout seconds.  When the timeout\n"
"is zero, the command blocks indefinitely.\n"},
{ NULL, XTRA_RETURN,
"An array with the name of the list follwed by the left most item\n"
"popped from the list.  If timeout expires, *null* is returned.\n"},
{ &xtra[319], XTRA_SHORT, "block and rpop list"},
{ &xtra[320], XTRA_USAGE, "brpop key [key ...] timeout\n"},
{ &xtra[321], XTRA_EXAMPLE, "> brpop l m 0\n"
"[\"l\",\"three\"]\n"},
{ &xtra[322], XTRA_DESCR,
"Right pop the list and return the pair of list name and value.  If the\n"
"list is empty, block and wait for timeout seconds.  When the timeout\n"
"is zero, the command blocks indefinitely.\n"},
{ NULL, XTRA_RETURN,
"An array with the name of the list follwed by the right most item\n"
"popped from the list.  If timeout expires, *null* is returned.\n"},
{ &xtra[324], XTRA_SHORT, "block rpop then lpush"},
{ &xtra[325], XTRA_USAGE, "brpoplpush src dest timeout\n"},
{ &xtra[326], XTRA_EXAMPLE,
"> lpush l one\n"
"1\n"
"> brpoplpush l m 0\n"
"\"one\"\n"
"> lrange l 0 -1\n"
"[]\n"
"> lrange m 0 -1\n"
"[\"one\"]\n"},
{ &xtra[327], XTRA_DESCR,
"Right pop the source list and left push the destination list.  If\n"
"source is empty, block and wait for an element.  The timeout is in\n"
"seconds and when it is zero, the command blocks indefinitely.\n"},
{ NULL, XTRA_RETURN,
"A string of the element transferred or *null* when timeout expires.\n"},
{ &xtra[329], XTRA_SHORT, "get list elem at index"},
{ &xtra[330], XTRA_USAGE, "lindex key idx\n"},
{ &xtra[331], XTRA_EXAMPLE, "> lindex m 0\n"
"\"one\"\n"
"> lindex m 10\n"
"nil\n"},
{ &xtra[332], XTRA_DESCR,
"Get list element at index.  Index starts at zero and ends at list\n"
"length - 1.\n"},
{ NULL, XTRA_RETURN,
"A string of the element at index or *nil* when index is out of range.\n"},
{ &xtra[334], XTRA_SHORT, "insert list elem"},
{ &xtra[335], XTRA_USAGE, "linsert key before | after piv val\n"},
{ &xtra[336], XTRA_EXAMPLE,
"> linsert m after two three\n"
"3\n"
"> linsert m after four five\n"
"-1\n"
"> lrange m 0 -1\n"
"[\"one\",\"two\",\"three\"]\n"},
{ &xtra[337], XTRA_DESCR,
"Insert into list an value before or after the element named by piv.\n"},
{ NULL, XTRA_RETURN,
"The count of elements in the list after inserting the new element, or\n"
"*-1* when the piv is not found.\n"},
{ &xtra[339], XTRA_SHORT, "get list length"},
{ &xtra[340], XTRA_USAGE, "llen key\n"},
{ &xtra[341], XTRA_EXAMPLE, "> llen m\n"
"3\n"},
{ &xtra[342], XTRA_DESCR, "Get list length.\n"},
{ NULL, XTRA_RETURN,
"The count of elements in list, *0* if list doesn't exist.\n"},
{ &xtra[344], XTRA_SHORT, "left pop list elem"},
{ &xtra[345], XTRA_USAGE, "lpop key\n"},
{ &xtra[346], XTRA_EXAMPLE,
"> lpush x one\n"
"1\n"
"> lpop x\n"
"\"one\"\n"
"> lpop x\n"
"nil\n"
"> type x\n"
"'none'\n"},
{ &xtra[347], XTRA_DESCR,
"Left pop the element from the list.  The list key is removed when\n"
"there are zero elements left.\n"},
{ NULL, XTRA_RETURN,
"The string value of the element or *nil* if list doesn't exist.\n"},
{ &xtra[349], XTRA_SHORT, "left push list elem"},
{ &xtra[350], XTRA_USAGE, "lpush key val [val ..]\n"},
{ &xtra[351], XTRA_EXAMPLE, "> lpush x one two three\n"
"3\n"},
{ &xtra[352], XTRA_DESCR, "Left push elements to the list.\n"},
{ NULL, XTRA_RETURN,
"The length of the list after elements are added.\n"},
{ &xtra[354], XTRA_SHORT, "left push if exists"},
{ &xtra[355], XTRA_USAGE, "lpushx key val [val ..]\n"},
{ &xtra[356], XTRA_EXAMPLE,
"> lpushx y one two three\n"
"0\n"
"> type y\n"
"'none'\n"
"> lpushx x one two three\n"
"6\n"},
{ &xtra[357], XTRA_DESCR,
"Left push elements to the list only if it exists.\n"},
{ NULL, XTRA_RETURN,
"The length of the list after elements are added.\n"},
{ &xtra[359], XTRA_SHORT, "get range of elems"},
{ &xtra[360], XTRA_USAGE, "lrange key start stop\n"},
{ &xtra[361], XTRA_EXAMPLE,
"> lrange x 0 -1\n"
"[\"three\",\"two\",\"one\",\"three\",\"two\",\"one\"]\n"
"> lrange x 6 10\n"
"[]\n"},
{ &xtra[362], XTRA_DESCR,
"Get a range of elements from the list.  If list doesn't exist or range\n"
"has zero elements, an empty array is returned.  A negative index\n"
"starts from the end of the list:  *-1* is the last element, *-2* is\n"
"the second last element.\n"},
{ NULL, XTRA_RETURN,
"An array of elements between the start and stop indexes, inclusive.\n"},
{ &xtra[364], XTRA_SHORT, "remove count elems"},
{ &xtra[365], XTRA_USAGE, "lrem key count value\n"},
{ &xtra[366], XTRA_EXAMPLE,
"> lrange x 0 -1\n"
"[\"three\",\"two\",\"one\",\"three\",\"two\",\"one\"]\n"
"> lrem x 1 one\n"
"1\n"
"> lrem x 1 one\n"
"1\n"
"> lrem x 1 one\n"
"0\n"
"> lrange x 0 -1\n"
"[\"three\",\"two\",\"three\",\"two\"]\n"},
{ &xtra[367], XTRA_DESCR,
"Remove count list elements which match the value.\n"},
{ NULL, XTRA_RETURN, "An integer count of elements removed.\n"},
{ &xtra[369], XTRA_SHORT, "set list elem at index"},
{ &xtra[370], XTRA_USAGE, "lset key idx value\n"},
{ &xtra[371], XTRA_EXAMPLE,
"> lpush l one two three\n"
"3\n"
"> lset l 1 TWO\n"
"'OK'\n"
"> lrange l 0 -1\n"
"[\"three\",\"TWO\",\"one\"]\n"},
{ &xtra[372], XTRA_DESCR,
"Set the list element at index.  Index is zero based.\n"},
{ NULL, XTRA_RETURN,
"*OK* if success, error if out of range or not found.\n"},
{ &xtra[374], XTRA_SHORT, "trim list elems"},
{ &xtra[375], XTRA_USAGE, "ltrim key start stop\n"},
{ &xtra[376], XTRA_EXAMPLE,
"> lpush x one two three one two three\n"
"6\n"
"> ltrim x 4 10\n"
"'OK'\n"
"> lrange x 0 -1\n"
"[\"two\",\"one\"]\n"},
{ &xtra[377], XTRA_DESCR,
"Trim list to range.  If start is beyond the end of the list, then all\n"
"elements are removed.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[379], XTRA_SHORT, "right pop list elem"},
{ &xtra[380], XTRA_USAGE, "rpop key\n"},
{ &xtra[381], XTRA_EXAMPLE,
"> rpush x two three\n"
"2\n"
"> rpop x\n"
"\"three\"\n"
"> rpop x\n"
"\"two\"\n"
"> rpop x\n"
"nil\n"
"> type x\n"
"'none'\n"},
{ &xtra[382], XTRA_DESCR,
"Right pop the element from the list.  The list key is removed when\n"
"there are zero elements left.\n"},
{ NULL, XTRA_RETURN,
"The string value of the element or *nil* if list doesn't exist.\n"},
{ &xtra[384], XTRA_SHORT, "right pop left push"},
{ &xtra[385], XTRA_USAGE, "rpoplpush src dest\n"},
{ &xtra[386], XTRA_EXAMPLE,
"> rpush x two three\n"
"2\n"
"> rpoplpush x y\n"
"\"three\"\n"
"> rpoplpush x y\n"
"\"two\"\n"
"> rpoplpush x y\n"
"nil\n"},
{ &xtra[387], XTRA_DESCR,
"Right pop the source list and left push the destination list.  If\n"
"source is empty, return *nil*.\n"},
{ NULL, XTRA_RETURN,
"A string of the element transferred or *nil*.\n"},
{ &xtra[389], XTRA_SHORT, "right push elem"},
{ &xtra[390], XTRA_USAGE, "rpush key [val ...]\n"},
{ &xtra[391], XTRA_EXAMPLE, "> rpush x one two three\n"
"3\n"},
{ &xtra[392], XTRA_DESCR, "Right push elements to the list.\n"},
{ NULL, XTRA_RETURN,
"The length of the list after elements are added.\n"},
{ &xtra[394], XTRA_SHORT, "right push if exist"},
{ &xtra[395], XTRA_USAGE, "rpushx key [val ...]\n"},
{ &xtra[396], XTRA_EXAMPLE,
"> rpushx y one two three\n"
"0\n"
"> type y\n"
"'none'\n"
"> rpush x one two three\n"
"3\n"
"> rpushx x one two three\n"
"6\n"},
{ &xtra[397], XTRA_DESCR,
"Right push elements to the list only if it exists.\n"},
{ NULL, XTRA_RETURN,
"The length of the list after elements are added.\n"},
{ &xtra[399], XTRA_SHORT, "append a value"},
{ &xtra[400], XTRA_USAGE, "happend key field val [val ...]\n"},
{ &xtra[401], XTRA_EXAMPLE,
"> happend h f v\n"
"1\n"
"> happend h f w\n"
"0\n"
"> hgetall h\n"
"[\"f\",\"vw\"]\n"},
{ &xtra[402], XTRA_DESCR, "Append a string to a field value.\n"},
{ NULL, XTRA_RETURN,
"An integer 1 or 0 indicating whether the field was created.\n"},
{ &xtra[404], XTRA_SHORT, "delete fields"},
{ &xtra[405], XTRA_USAGE, "hdel key field [field ...]\n"},
{ &xtra[406], XTRA_EXAMPLE, "> hmset h f 1 g 2\n"
"'OK'\n"
"> hdel h f g\n"
"2\n"},
{ &xtra[407], XTRA_DESCR, "Remove one or more fields from a hash set.\n"},
{ NULL, XTRA_RETURN,
"An integer indicating how many fields were removed.\n"},
{ &xtra[409], XTRA_SHORT, "if field exists"},
{ &xtra[410], XTRA_USAGE, "hexists key field\n"},
{ &xtra[411], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hexists h f\n"
"1\n"
"> hexists h h\n"
"0\n"},
{ &xtra[412], XTRA_DESCR, "Test whether field exists in hash.\n"},
{ NULL, XTRA_RETURN,
"An integer *1* indicating the field exists or *0* when it doesn't.\n"},
{ &xtra[414], XTRA_SHORT, "get a field value"},
{ &xtra[415], XTRA_USAGE, "hget key field\n"},
{ &xtra[416], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hget h f\n"
"\"1\"\n"
"> hget h h\n"
"nil\n"},
{ &xtra[417], XTRA_DESCR, "Get the value associated with field.\n"},
{ NULL, XTRA_RETURN,
"A string value or *nil* when the field does not exist.\n"},
{ &xtra[419], XTRA_SHORT, "get all field values"},
{ &xtra[420], XTRA_USAGE, "hgetall key\n"},
{ &xtra[421], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hgetall h\n"
"[\"f\",\"1\",\"g\",\"2\"]\n"},
{ &xtra[422], XTRA_DESCR,
"Get all of the fields and values associated with the hash stored at\n"
"key.\n"},
{ NULL, XTRA_RETURN,
"An array of field value pairs.  An empty array when key doesn't exist.\n"},
{ &xtra[424], XTRA_SHORT, "incr field"},
{ &xtra[425], XTRA_USAGE, "hincrby key field int\n"},
{ &xtra[426], XTRA_EXAMPLE, "> hmset h f 1 g 2\n"
"'OK'\n"
"> hincrby h f 10\n"
"11\n"},
{ &xtra[427], XTRA_DESCR, "Add an integer value to field.\n"},
{ NULL, XTRA_RETURN,
"The integer value after incrementing the integer or an error if the\n"
"value stored in field is not an integer.\n"},
{ &xtra[429], XTRA_SHORT, "incr field"},
{ &xtra[430], XTRA_USAGE, "hincrbyfloat key field num\n"},
{ &xtra[431], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hincrbyfloat h f 123456.66\n"
"\"123457.66\"\n"},
{ &xtra[432], XTRA_DESCR,
"Add a numeric value to field.  This uses 128 bit decimal arithmetic\n"
"which has a 34 digit range and an exponent from -6143 to +6144.\n"
"https://en.wikipedia.org/wiki/Decimal128_floating-point_format\n"},
{ NULL, XTRA_RETURN,
"A string numeric value after incrementing the number or an error if\n"
"the value stored in field is not a number.\n"},
{ &xtra[434], XTRA_SHORT, "get all field keys"},
{ &xtra[435], XTRA_USAGE, "hkeys key\n"},
{ &xtra[436], XTRA_EXAMPLE, "> hmset h f 1 g 2\n"
"'OK'\n"
"> hkeys h\n"
"[\"f\",\"g\"]\n"},
{ &xtra[437], XTRA_DESCR, "Get all field keys in the hash.\n"},
{ NULL, XTRA_RETURN, "An array of field names.\n"},
{ &xtra[439], XTRA_SHORT, "get number of fields"},
{ &xtra[440], XTRA_USAGE, "hlen key\n"},
{ &xtra[441], XTRA_EXAMPLE, "> hmset h f 1 g 2\n"
"'OK'\n"
"> hlen h\n"
"2\n"},
{ &xtra[442], XTRA_DESCR,
"Get the number field value pairs in the hash.\n"},
{ NULL, XTRA_RETURN, "An integer count of the number of fields.\n"},
{ &xtra[444], XTRA_SHORT, "get multiple field vals"},
{ &xtra[445], XTRA_USAGE, "hmget key field [field ...]\n"},
{ &xtra[446], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hmget h f g h\n"
"[\"1\",\"2\",nil]\n"},
{ &xtra[447], XTRA_DESCR,
"Get multiple values from a hash.  If a field doesn't exist, a *nil* is\n"
"returned.\n"},
{ NULL, XTRA_RETURN, "An array of values or *nil*.\n"},
{ &xtra[449], XTRA_SHORT, "set multiple field vals"},
{ &xtra[450], XTRA_USAGE, "hmset key field value [field value ...]\n"},
{ &xtra[451], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hmset h g 3 tree 50\n"
"'OK'\n"
"> hgetall h\n"
"[\"f\",\"1\",\"g\",\"3\",\"tree\",\"50\"]\n"},
{ &xtra[452], XTRA_DESCR, "Set multiple field value pairs in the hash.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[454], XTRA_SHORT, "set a field value"},
{ &xtra[455], XTRA_USAGE, "hset key field value [field value ...]\n"},
{ &xtra[456], XTRA_EXAMPLE,
"> hset h f 1 g 2\n"
"2\n"
"> hset h g 3 tree 50\n"
"1\n"
"> hgetall h\n"
"[\"f\",\"1\",\"g\",\"3\",\"tree\",\"50\"]\n"},
{ &xtra[457], XTRA_DESCR,
"Set multiple field value pairs in the hash.  Preexisting fields will\n"
"be overwritten, and new fields will be added to the hash.\n"},
{ NULL, XTRA_RETURN,
"An integer indicating number of fields created.\n"},
{ &xtra[459], XTRA_SHORT, "set if not present"},
{ &xtra[460], XTRA_USAGE, "hsetnx key field value\n"},
{ &xtra[461], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hsetnx h tree 50\n"
"1\n"
"> hsetnx h g 3\n"
"0\n"
"> hgetall h\n"
"[\"f\",\"1\",\"g\",\"2\",\"tree\",\"50\"]\n"},
{ &xtra[462], XTRA_DESCR,
"Set a field in a hash only when it does not exist.\n"},
{ NULL, XTRA_RETURN, "An integer *1* or *0* indicating success.\n"},
{ &xtra[464], XTRA_SHORT, "get strlen of field val"},
{ &xtra[465], XTRA_USAGE, "hstrlen key field\n"},
{ &xtra[466], XTRA_EXAMPLE, "> hsetnx h tree 50\n"
"1\n"
"> hstrlen h tree\n"
"2\n"},
{ &xtra[467], XTRA_DESCR,
"Get the string length of value stored with field, *0* if field does\n"
"not exist.\n"},
{ NULL, XTRA_RETURN,
"An integer string length, which is the count of the 8 bit characters\n"
"in the value.\n"},
{ &xtra[469], XTRA_SHORT, "get all values"},
{ &xtra[470], XTRA_USAGE, "hvals key\n"},
{ &xtra[471], XTRA_EXAMPLE,
"> hmset h f 1 g 2\n"
"'OK'\n"
"> hvals h\n"
"[\"f\",\"1\",\"g\",\"2\"]\n"},
{ &xtra[472], XTRA_DESCR, "Get all of the values stored in the hash.\n"},
{ NULL, XTRA_RETURN,
"An array of all the values or *nil* when hash does not exist.\n"},
{ &xtra[474], XTRA_SHORT, "iterate fields"},
{ &xtra[475], XTRA_USAGE, "hscan key cursor [match pattern] [count int]\n"},
{ &xtra[476], XTRA_EXAMPLE,
"> hset h abc 1 abb 2 abd 3 xyz 4 zzz 5\n"
"5\n"
"> hscan h 0 match a* count 1\n"
"[\"2\",[\"abc\",\"1\"]]\n"
"> hscan h 2 match a* count 1\n"
"[\"3\",[\"abb\",\"2\"]]\n"
"> hscan h 3 match a* count 1\n"
"[\"4\",[\"abd\",\"3\"]]\n"
"> hscan h 4 match a* count 1\n"
"[\"0\",[]]\n"
"> hscan h 0\n"
"[\"0\",[\"abc\",\"1\",\"abb\",\"2\",\"abd\",\"3\",\"xyz\",\"4\",\"zzz\",\"5\"]]\n"
"> hscan h 5 match a* count 1\n"
"[\"0\",[]]\n"},
{ &xtra[477], XTRA_DESCR,
"Get the fields and values which match a pattern.  The cursor is the\n"
"offset into the scan where the results will start.  If the cursor is\n"
"equal to 3, then the match will start at the 3rd field in the hash.\n"},
{ NULL, XTRA_RETURN,
"An array within an array.  The outer array is the cursor counter, the\n"
"inner array is the fields and values.\n"},
{ &xtra[479], XTRA_SHORT, "add to set"},
{ &xtra[480], XTRA_USAGE, "sadd key mem [mem ...]\n"},
{ &xtra[481], XTRA_EXAMPLE, "> sadd s x y z\n"
"3\n"
"> sadd s z a b\n"
"2\n"},
{ &xtra[482], XTRA_DESCR, "Add one or more members to a set.\n"},
{ NULL, XTRA_RETURN, "An integer count of unique members added.\n"},
{ &xtra[484], XTRA_SHORT, "get member count"},
{ &xtra[485], XTRA_USAGE, "scard key\n"},
{ &xtra[486], XTRA_EXAMPLE, "> sadd s x y z\n"
"3\n"
"> scard s\n"
"3\n"},
{ &xtra[487], XTRA_DESCR, "Get the count of set members.\n"},
{ NULL, XTRA_RETURN, "An integer count of members.\n"},
{ &xtra[489], XTRA_SHORT, "subtract sets"},
{ &xtra[490], XTRA_USAGE, "sdiff key [key ...]\n"},
{ &xtra[491], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> sdiff s t\n"
"[\"y\"]\n"
"> sdiff t s\n"
"[\"Y\"]\n"},
{ &xtra[492], XTRA_DESCR,
"Subtract sets.  Remove members of the first set using the members of\n"
"the the other sets.\n"},
{ NULL, XTRA_RETURN, "An array of members.\n"},
{ &xtra[494], XTRA_SHORT, "subtract and store"},
{ &xtra[495], XTRA_USAGE, "sdiffstore dest key [key ...]\n"},
{ &xtra[496], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> sdiffstore sd s t\n"
"1\n"
"> smembers sd\n"
"[\"y\"]\n"
"> sdiffstore td t s\n"
"1\n"
"> smembers td\n"
"[\"Y\"]\n"},
{ &xtra[497], XTRA_DESCR,
"Remove members of the first set using the members of the the other\n"
"sets.  Store the result in the dest key.\n"},
{ NULL, XTRA_RETURN,
"A count of members stored in the set at the dest key.\n"},
{ &xtra[499], XTRA_SHORT, "intersect sets"},
{ &xtra[500], XTRA_USAGE, "sinter key [key ...]\n"},
{ &xtra[501], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> sinter s t\n"
"[\"x\", \"z\"]\n"},
{ &xtra[502], XTRA_DESCR,
"Intersect all the sets, only keep a member if it is in all sets.\n"},
{ NULL, XTRA_RETURN, "An array of members.\n"},
{ &xtra[504], XTRA_SHORT, "intersect and store"},
{ &xtra[505], XTRA_USAGE, "sinterstore key [key ...]\n"},
{ &xtra[506], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> sinterstore si s t\n"
"2\n"
"> smembers si\n"
"[\"x\", \"z\"]\n"},
{ &xtra[507], XTRA_DESCR,
"Intersect all the sets and store the result in the dest key.\n"},
{ NULL, XTRA_RETURN,
"A count of members stored in the set at the dest key.\n"},
{ &xtra[509], XTRA_SHORT, "test membership"},
{ &xtra[510], XTRA_USAGE, "sismember key mem\n"},
{ &xtra[511], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sismember s x\n"
"1\n"
"> sismember s Y\n"
"0\n"},
{ &xtra[512], XTRA_DESCR, "Test whether member is present in a set.\n"},
{ NULL, XTRA_RETURN,
"A *1* is returned if it is a member, a *0* if not.\n"},
{ &xtra[514], XTRA_SHORT, "get all members"},
{ &xtra[515], XTRA_USAGE, "smembers key\n"},
{ &xtra[516], XTRA_EXAMPLE, "> sadd s x y z\n"
"3\n"
"> smembers s\n"
"[\"x\",\"y\",\"z\"]\n"},
{ &xtra[517], XTRA_DESCR, "Get all the members in a set.\n"},
{ NULL, XTRA_RETURN,
"An array of set members, which could be empty if the key doesn't\n"
"exist.\n"},
{ &xtra[519], XTRA_SHORT, "move member to set"},
{ &xtra[520], XTRA_USAGE, "smove src dest mem\n"},
{ &xtra[521], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> smove s t x\n"
"1\n"
"> smove s t Y\n"
"0\n"
"> smove s t a\n"
"0\n"
"> smove s t y\n"
"1\n"
"> smembers s\n"
"[\"z\"]\n"
"> smembers t\n"
"[\"x\",\"Y\",\"z\",\"y\"]\n"},
{ &xtra[522], XTRA_DESCR,
"Move a member to another set, which removes the member from the source\n"
"and only adds it the destination if it exists in the source.\n"},
{ NULL, XTRA_RETURN,
"A *1* is returned if the member exists in the source and is moved and\n"
"a *0* is returned if the member does not exist in the source.\n"},
{ &xtra[524], XTRA_SHORT, "remove rand members"},
{ &xtra[525], XTRA_USAGE, "spop key [count]\n"},
{ &xtra[526], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> spop s\n"
"[\"y\"]\n"
"> spop t 300\n"
"[\"x\",\"Y\",\"z\"]\n"
"> smembers s\n"
"[\"x\",\"z\"]\n"
"> smembers t\n"
"[]\n"
"> spop t\n"
"[]\n"},
{ &xtra[527], XTRA_DESCR,
"Remove count random members from the set and return them.\n"},
{ NULL, XTRA_RETURN,
"An array of members removed, which may be less than count if there are\n"
"not enough in the set to fulfill the total.\n"},
{ &xtra[529], XTRA_SHORT, "get rand members"},
{ &xtra[530], XTRA_USAGE, "srandmember key [count]\n"},
{ &xtra[531], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> srandmember s\n"
"[\"y\"]\n"
"> srandmember t 300\n"
"[\"x\",\"Y\",\"z\"]\n"},
{ &xtra[532], XTRA_DESCR,
"Get count random members from the set and return them.\n"},
{ NULL, XTRA_RETURN,
"An array of members removed, which may be less than count if there are\n"
"not enough in the set to fulfill the total.\n"},
{ &xtra[534], XTRA_SHORT, "remove members"},
{ &xtra[535], XTRA_USAGE, "srem key mem [mem ...]\n"},
{ &xtra[536], XTRA_EXAMPLE, "> sadd s x y z\n"
"3\n"
"> srem s y Y z\n"
"2\n"},
{ &xtra[537], XTRA_DESCR, "Remove one or more members from the set.\n"},
{ NULL, XTRA_RETURN, "An integer count of members removed.\n"},
{ &xtra[539], XTRA_SHORT, "union sets"},
{ &xtra[540], XTRA_USAGE, "sunion key [key ...]\n"},
{ &xtra[541], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> sunion s t\n"
"[\"x\",\"y\",\"Y\",\"z\"]\n"},
{ &xtra[542], XTRA_DESCR, "Union sets and return members.\n"},
{ NULL, XTRA_RETURN, "An array of members.\n"},
{ &xtra[544], XTRA_SHORT, "union and store"},
{ &xtra[545], XTRA_USAGE, "sunionstore dest key [key ...]\n"},
{ &xtra[546], XTRA_EXAMPLE,
"> sadd s x y z\n"
"3\n"
"> sadd t x Y z\n"
"3\n"
"> sunionstore su s t\n"
"4\n"
"> smembers su\n"
"[\"x\",\"y\",\"Y\",\"z\"]\n"},
{ &xtra[547], XTRA_DESCR,
"Union all the sets and store the result in the dest key.\n"},
{ NULL, XTRA_RETURN,
"A count of members stored in the set at the dest key.\n"},
{ &xtra[549], XTRA_SHORT, "iterate and match"},
{ &xtra[550], XTRA_USAGE, "sscan key curs [match pattern] [count cnt]\n"},
{ &xtra[551], XTRA_EXAMPLE,
"> sadd s abc abb abd xyz zzz\n"
"5\n"
"> sscan s 0 match a* count 1\n"
"[\"2\",[\"abc\"]]\n"
"> sscan s 2 match a* count 1\n"
"[\"3\",[\"abb\"]]\n"
"> sscan s 3 match a* count 1\n"
"[\"4\",[\"abd\"]]\n"
"> sscan s 4 match a* count 1\n"
"[\"0\",[]]\n"
"> sscan s 0\n"
"[\"0\",[\"abc\",\"abb\",\"abd\",\"xyz\",\"zzz\"]]\n"
"> sscan s 5 match a* count 1\n"
"[\"0\",[]]\n"},
{ &xtra[552], XTRA_DESCR,
"Get the fields and values which match a pattern.  The cursor is the\n"
"offset into the scan where the results will start.  If the cursor is\n"
"equal to 3, then the match will start at the 3rd member of the set.\n"},
{ NULL, XTRA_RETURN,
"An array within an array.  The outer array is the cursor counter, the\n"
"inner array are the members matched.\n"},
{ &xtra[554], XTRA_SHORT, "add to zset"},
{ &xtra[555], XTRA_USAGE,
"zadd key [nx | xx] [ch] [incr] score mem [score mem ...]\n"},
{ &xtra[556], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c\n"
"3\n"
"> zrange z 0 -1 withscores\n"
"[\"a\",\"10\",\"b\",\"20\",\"c\",\"30\"]\n"
"> zadd z incr 1.1 a 2.2 b 3.3 c\n"
"\"33.3\"\n"
"> zrange z 0 -1 withscores\n"
"[\"a\",\"11.1\",\"b\",\"22.2\",\"c\",\"33.3\"]\n"
"> zadd z incr 1 a\n"
"\"12.1\"\n"
"> zadd z nx 10 a 40 d\n"
"1\n"
"> zrange z 0 -1 withscores\n"
"[\"a\",\"12.1\",\"b\",\"22.2\",\"c\",\"33.3\",\"d\",\"40\"]\n"},
{ &xtra[557], XTRA_DESCR,
"Add members to zset with score, optionally with a no exist (*nx*) flag\n"
"or must exist (*xx*) flag.  The *ch* flag alters the count to the\n"
"number members changed, otherwise it is the count of the number of\n"
"members created.  The *incr* flag causes the score to be added to the\n"
"existing instead of replacing it.  The score is stored as 64 bit\n"
"decimal number, which has a 16 digit precision and -383 to +384\n"
"exponent range.\n"
"https://en.wikipedia.org/wiki/Decimal64_floating-point_format\n"},
{ NULL, XTRA_RETURN,
"A count of members created, or changed when the *ch* flag is set.  If\n"
"incr used, then the result is the new score.  A string type is used\n"
"for scores since it is a decimal real.\n"},
{ &xtra[559], XTRA_SHORT, "get member count"},
{ &xtra[560], XTRA_USAGE, "zcard key\n"},
{ &xtra[561], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c\n"
"3\n"
"> zrange z 0 -1\n"
"[\"a\",\"b\",\"c\"]\n"
"> zcard z\n"
"3\n"},
{ &xtra[562], XTRA_DESCR, "Get a count of the number members.\n"},
{ NULL, XTRA_RETURN,
"An integer count, *0* if the key doesn't exist.\n"},
{ &xtra[564], XTRA_SHORT, "count within bounds"},
{ &xtra[565], XTRA_USAGE, "zcount key min max\n"},
{ &xtra[566], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c\n"
"3\n"
"> zcount z 10 30\n"
"3\n"
"> zcount z 15 30\n"
"2\n"},
{ &xtra[567], XTRA_DESCR, "Get number of members within a bounds.\n"},
{ NULL, XTRA_RETURN,
"An integer count, *0* if the key doesn't exist.\n"},
{ &xtra[569], XTRA_SHORT, "incr score"},
{ &xtra[570], XTRA_USAGE, "zincrby key incr mem\n"},
{ &xtra[571], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c\n"
"3\n"
"> zincrby z 1.5 a\n"
"\"21.5\"\n"
"> zrange z 0 -1 withscores\n"
"[\"b\",\"20\",\"a\",\"21.5\",\"c\",\"30\"]\n"
"> zincrby z 1.5 A\n"
"\"1.5\"\n"
"> zrange z 0 -1 withscores\n"
"[\"A\",\"1.5\",\"b\",\"20\",\"a\",\"21.5\",\"c\",\"30\"]\n"},
{ &xtra[572], XTRA_DESCR,
"Add a score to member, if member doesn't exists, create it.\n"},
{ NULL, XTRA_RETURN, "The score after incrementing it.\n"},
{ &xtra[574], XTRA_SHORT, "intersect and store"},
{ &xtra[575], XTRA_USAGE,
"zinterstore dest num key [key ...] [weights w [w ...]]\n"
" [aggregate sum|min|max]\n"},
{ &xtra[576], XTRA_EXAMPLE,
"> zadd z1 10 a 20 b 30 c\n"
"3\n"
"> zadd z2 40 d 30 c 10 b\n"
"3\n"
"> zinterstore z3 2 z1 z2\n"
"2\n"
"> zrange z3 0 -1 withscores\n"
"[\"b\",\"30\",\"c\",\"60\"]\n"},
{ &xtra[577], XTRA_DESCR,
"Intersect zsets and store in destination key.  The members which are\n"
"in both sets are combined into the destination set.  The score is a\n"
"combination of both members, depending on the weight given to each set\n"
"and how it is aggregated.  The default is weight 1 for each set (or no\n"
"weight), and aggregating by sum.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the members in the new set.\n"},
{ &xtra[579], XTRA_SHORT, "count lexical bounds"},
{ &xtra[580], XTRA_USAGE, "zlexcount key min max\n"},
{ &xtra[581], XTRA_EXAMPLE,
"> zadd z 10 a 10 b 10 c 10 d\n"
"4\n"
"> zlexcount z a d\n"
"4\n"
"> zcount z 10 10\n"
"4\n"},
{ &xtra[582], XTRA_DESCR,
"Count members in a zset within a lexical bounds, when all elements\n"
"have the same score (and this only works when all members have the\n"
"same score).\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of members between an inclusive lexical\n"
"bounds.\n"},
{ &xtra[584], XTRA_SHORT, "get members with range"},
{ &xtra[585], XTRA_USAGE, "zrange key start stop [withscores]\n"},
{ &xtra[586], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zrange z 2 3 withscores\n"
"[\"c\",\"30\",\"d\",\"40\"]\n"
"> zrange z 0 -1\n"
"[\"a\",\"b\",\"c\",\"d\"]\n"},
{ &xtra[587], XTRA_DESCR,
"Get range of members between ranked indices.  The elements are sorted\n"
"by score, low to high, so the 0th indexed element is the lowest score\n"
"and ranked lowest.  The start and stop can be negative, which would\n"
"index from the highest score, so the -1 indexed element is the highest\n"
"score and ranked highest.\n"},
{ NULL, XTRA_RETURN,
"An array of members with scores if requested.\n"},
{ &xtra[589], XTRA_SHORT, "get with lex range"},
{ &xtra[590], XTRA_USAGE, "zrangebylex key min max [limit off cnt]\n"},
{ &xtra[591], XTRA_EXAMPLE,
"> zadd z 10 a 10 b 10 c 10 d\n"
"4\n"
"> zrangebylex z [a [b\n"
"[\"a\",\"b\"]\n"
"> zrangebylex z - +\n"
"[\"a\",\"b\",\"c\",\"d\"]\n"
"> zrangebylex z - + limit 0 1\n"
"[\"a\"]\n"
"> zrangebylex z - + limit 1 1\n"
"[\"b\"]\n"},
{ &xtra[592], XTRA_DESCR,
"Get members in a zset within a lexical bounds, when all elements have\n"
"the same score (and this only works when all members have the same\n"
"score).\n"},
{ NULL, XTRA_RETURN, "An array of members.\n"},
{ &xtra[594], XTRA_SHORT, "get rev lex range"},
{ &xtra[595], XTRA_USAGE, "zrevrangebylex key min max [limit off cnt]\n"},
{ &xtra[596], XTRA_EXAMPLE,
"> zadd z 10 a 10 b 10 c 10 d\n"
"4\n"
"> zrevrangebylex z [c [a\n"
"[\"c\",\"b\",\"a\"]\n"
"> zrevrangebylex z + -\n"
"[\"d\",\"c\",\"b\",\"a\"]\n"
"> zrevrangebylex z + - limit 0 1\n"
"[\"d\"]\n"
"> zrevrangebylex z + - limit 1 1\n"
"[\"c\"]\n"},
{ &xtra[597], XTRA_DESCR,
"Get members in a zset within a lexical bounds high to low, in reverse,\n"
"when all elements have the same score (and this only works when all\n"
"members have the same score).\n"},
{ NULL, XTRA_RETURN, "An array of members.\n"},
{ &xtra[599], XTRA_SHORT, "get range by score"},
{ &xtra[600], XTRA_USAGE, "zrangebyscore key min max [withscores]\n"},
{ &xtra[601], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zrangebyscore z 10 30\n"
"[\"a\",\"b\",\"c\"]\n"
"> zrangebyscore z (1 [2 withscores\n"
"[\"b\",\"20\"]\n"},
{ &xtra[602], XTRA_DESCR,
"Get range of members between scores.  The start is the lowest score\n"
"and the stop is the highest score.  The members are returned from the\n"
"lowest to the highest, in score order.\n"},
{ NULL, XTRA_RETURN,
"An array of members, with scores if requested.\n"},
{ &xtra[604], XTRA_SHORT, "get rank of member"},
{ &xtra[605], XTRA_USAGE, "zrank key mem\n"},
{ &xtra[606], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zrank z b\n"
"1\n"
"> zrank z c\n"
"2\n"
"> zrank z f\n"
"nil\n"},
{ &xtra[607], XTRA_DESCR,
"Get index of member, it's rank, where it is ordered by score.\n"},
{ NULL, XTRA_RETURN,
"An integer indicating rank of member, *nil* if member not found.\n"},
{ &xtra[609], XTRA_SHORT, "remove members"},
{ &xtra[610], XTRA_USAGE, "zrem key mem [mem ...]\n"},
{ &xtra[611], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zrem z b c f\n"
"2\n"
"> zrange z 0 -1 withscores\n"
"[\"a\",\"10\",\"d\",\"40\"]\n"},
{ &xtra[612], XTRA_DESCR, "Remove members by name.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* if removed, *0* if not removed.\n"},
{ &xtra[614], XTRA_SHORT, "remove by lex"},
{ &xtra[615], XTRA_USAGE, "zremrangebylex key min max\n"},
{ &xtra[616], XTRA_EXAMPLE,
"> zadd z 10 a 10 b 10 c 10 d\n"
"4\n"
"> zremrangebylex z [a [c\n"
"3\n"
"> zrange z 0 -1 withscores\n"
"[\"d\",\"10\"]\n"},
{ &xtra[617], XTRA_DESCR,
"Remove members from a zset within a lexical bounds high to low, in\n"
"reverse, when all elements have the same score (and this only works\n"
"when all members have the same score).\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of members removed.\n"},
{ &xtra[619], XTRA_SHORT, "remove by rank"},
{ &xtra[620], XTRA_USAGE, "zremrangebyrank key start stop\n"},
{ &xtra[621], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zremrangebyrank z 1 2\n"
"2\n"
"> zrange z 0 -1 withscores\n"
"[\"a\",\"10\",\"d\",\"40\"]\n"},
{ &xtra[622], XTRA_DESCR,
"Remove members from a zset by rank, which is the index of order that\n"
"they are sorted.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of members removed.\n"},
{ &xtra[624], XTRA_SHORT, "remove by score"},
{ &xtra[625], XTRA_USAGE, "zremrangebyscore key start stop\n"},
{ &xtra[626], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zremrangebyscore z 10 20\n"
"2\n"
"> zrange z 0 -1 withscores\n"
"[\"c\",\"30\",\"d\",\"40\"]\n"},
{ &xtra[627], XTRA_DESCR, "Remove members from a zset by score.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of members removed.\n"},
{ &xtra[629], XTRA_SHORT, "get reverse range"},
{ &xtra[630], XTRA_USAGE, "zrevrange key start stop [withscores]\n"},
{ &xtra[631], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zrevrange z 2 3 withscores\n"
"[\"b\",\"20\",\"a\",\"10\"]\n"
"> zrevrange z 0 -1\n"
"[\"d\",\"c\",\"b\",\"a\"]\n"},
{ &xtra[632], XTRA_DESCR,
"Get range of members between ranks.  The start is the lowest index of\n"
"the reverse ordered zset, the stop is the highest.  The members are\n"
"returned from low to high using a reverse ordered zset.\n"},
{ NULL, XTRA_RETURN,
"An array of members with scores if requested.\n"},
{ &xtra[634], XTRA_SHORT, "get reverse score"},
{ &xtra[635], XTRA_USAGE,
"zrevrangebyscore key start stop [withscores] [limit off cnt]\n"},
{ &xtra[636], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zrevrangebyscore z +inf -inf withscores\n"
"[\"d\",\"40\",\"c\",\"30\",\"b\",\"20\",\"a\",\"10\"]\n"
"> zrevrangebyscore z 20 10 withscores\n"
"[\"b\",\"20\",\"a\",\"10\"]\n"
"> zrevrangebyscore z (20 [10 withscores\n"
"[\"a\",\"10\"]\n"},
{ &xtra[637], XTRA_DESCR,
"Get reverse range of members between scores.  The start is the highest\n"
"score and the stop is the lowest score.  The members are returned from\n"
"the highest to the lowest, in reverse score order.\n"},
{ NULL, XTRA_RETURN,
"An array of members with scores if requested.\n"},
{ &xtra[639], XTRA_SHORT, "get reverse rank"},
{ &xtra[640], XTRA_USAGE, "zrevrank key mem\n"},
{ &xtra[641], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"40\n"
"> zrevrank z b\n"
"20\n"
"> zrevrank z c\n"
"10\n"
"> zrevrank z f\n"
"nil\n"},
{ &xtra[642], XTRA_DESCR,
"Get inverse rank index of member by name.  If the order of the zset is\n"
"reversed, then this is the index of the member.\n"},
{ NULL, XTRA_RETURN,
"An integer indicating rank of member, *nil* if member is not found.\n"},
{ &xtra[644], XTRA_SHORT, "get score of member"},
{ &xtra[645], XTRA_USAGE, "zscore key mem\n"},
{ &xtra[646], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zscore z a\n"
"\"10\"\n"
"> zscore z d\n"
"\"40\"\n"},
{ &xtra[647], XTRA_DESCR, "Get score of a member.\n"},
{ NULL, XTRA_RETURN,
"A string which contains a decimal value for the score.\n"},
{ &xtra[649], XTRA_SHORT, "store a union"},
{ &xtra[650], XTRA_USAGE,
"zunionstore dest num key [key ...] [weights w [w ...]]\n"
" [aggregate sum|min|max]\n"},
{ &xtra[651], XTRA_EXAMPLE,
"> zadd z1 10 a 20 b 30 c\n"
"3\n"
"> zadd z2 40 d 30 c 10 b\n"
"3\n"
"> zunionstore z3 2 z1 z2\n"
"4\n"
"> zrange z3 0 -1 withscores\n"
"[\"a\",\"10\",\"b\",\"30\",\"d\",\"40\",\"c\",\"60\"]\n"},
{ &xtra[652], XTRA_DESCR,
"Union zsets and store in destination key.  The members which are in\n"
"both sets are combined into the destination set.  The score is a\n"
"combination of both members, depending on the weight given to each set\n"
"and how it is aggregated.  The default is weight 1 for each set (or no\n"
"weight), and aggregating by sum.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the members in the new set.\n"},
{ &xtra[654], XTRA_SHORT, "iterate a zset"},
{ &xtra[655], XTRA_USAGE, "zscan key curs [match pattern] [count cnt]\n"},
{ &xtra[656], XTRA_EXAMPLE,
"> zadd z 50 abc 40 abb 30 abd 20 xyz 10 zzz\n"
"5\n"
"> zscan z 0 match a* count 1\n"
"[\"3\",[\"abd\",\"30\"]]\n"
"> zscan z 3 match a* count 1\n"
"[\"4\",[\"abb\",\"40\"]]\n"
"> zscan z 4 match a* count 1\n"
"[\"0\",[\"abc\",\"50\"]]\n"
"> zscan z 5 match a* count 1\n"
"[\"0\",[]]\n"
"> zscan z 0\n"
"[\"0\",[\"zzz\",\"10\",\"xyz\",\"20\",\"abd\",\"30\",\"abb\",\"40\",\"abc\",\"50\"]]\n"
"> zscan z 5 match a* count 1\n"
"[\"0\",[]]\n"},
{ &xtra[657], XTRA_DESCR,
"Get the fields and values which match a pattern.  The cursor is the\n"
"offset into the scan where the results will start.  If the cursor is\n"
"equal to 3, then the match will start at the 3rd member of the zset.\n"},
{ NULL, XTRA_RETURN,
"An array within an array.  The outer array is the cursor counter, the\n"
"inner array are the members matched with their scores.\n"},
{ &xtra[659], XTRA_SHORT, "remove minimum score"},
{ &xtra[660], XTRA_USAGE, "zpopmin key [count]\n"},
{ &xtra[661], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zpopmin z 2\n"
"[\"a\",\"10\",\"b\",\"20\"]\n"
"> zpopmin z 20\n"
"[\"c\",\"30\",\"d\",\"40\"]\n"
"> zpopmin z 20\n"
"[]\n"},
{ &xtra[662], XTRA_DESCR,
"Remove up to count members the lowest scores of the zset.  If not\n"
"enough members are currently in the set, truncate count to the number\n"
"of members in the set.\n"},
{ NULL, XTRA_RETURN,
"An array with the set of members and the scores, in the order they\n"
"were popped, an empty array is returned when the key doesn't exist.\n"},
{ &xtra[664], XTRA_SHORT, "remove maximum score"},
{ &xtra[665], XTRA_USAGE, "zpopmax key [count]\n"},
{ &xtra[666], XTRA_EXAMPLE,
"> zadd z 10 a 20 b 30 c 40 d\n"
"4\n"
"> zpopmax z 2\n"
"[\"d\",\"40\",\"c\",\"30\"]\n"
"> zpopmax z 20\n"
"[\"b\",\"20\",\"a\",\"10\"]\n"
"> zpopmax z 20\n"
"[]\n"},
{ &xtra[667], XTRA_DESCR,
"Remove up to count members the highest scores of the zset.  If not\n"
"enough members are currently in the set, truncate count to the number\n"
"of members in the set.\n"},
{ NULL, XTRA_RETURN,
"An array with the set of members and the scores, in the order they\n"
"were popped, an empty array is returned when the key doesn't exist.\n"},
{ &xtra[669], XTRA_SHORT, "block pop min score"},
{ &xtra[670], XTRA_USAGE, "bzpopmin key [key ...] timeout\n"},
{ &xtra[671], XTRA_EXAMPLE,
"> bzpopmin z x 2\n"
"null\n"
"> bzpopmin z x 0\n"
"[\"z\",\"a\",\"10\"]\n"
"> bzpopmin z x 0\n"},
{ &xtra[672], XTRA_DESCR,
"Remove lowest score member of the zset.  If no members are currently\n"
"in the zset, block and wait timeout seconds for a publisher to add\n"
"them.  Wait indefinitely when timeout is zero.\n"},
{ NULL, XTRA_RETURN,
"An array with the zset name and the member with scores.  If timeout\n"
"occurs, then null is returned.\n"},
{ &xtra[674], XTRA_SHORT, "block pop max score"},
{ &xtra[675], XTRA_USAGE, "bzpopmax key [key ...] timeout\n"},
{ &xtra[676], XTRA_EXAMPLE,
"> bzpopmax z x 2\n"
"null\n"
"> bzpopmax z x 0\n"
"[\"z\",\"d\",\"40\"]\n"
"> bzpopmax z x 0\n"},
{ &xtra[677], XTRA_DESCR,
"Remove hightest score member of the zset.  If no members are currently\n"
"in the zset, block and wait timeout seconds for a publisher to add\n"
"them.  Wait indefinitely when timeout is zero.\n"},
{ NULL, XTRA_RETURN,
"An array with the zset name and the member with scores.  If timeout\n"
"occurs, then null is returned.\n"},
{ &xtra[679], XTRA_SHORT, "add a pos to key"},
{ &xtra[680], XTRA_USAGE, "geoadd key long lat mem [long lat mem ...]\n"},
{ &xtra[681], XTRA_DESCR,
"Add longitude, latitude to key as member by converting the position to\n"
"a *Uber H3* hash and adding it to the set.  The members are ordered by\n"
"hash because hashes closest to eachother are also closest by spatual\n"
"distance.\n"},
{ NULL, XTRA_RETURN,
"An integer is returned indicating how many members were added which\n"
"did not already exist.\n"},
{ &xtra[683], XTRA_SHORT, "get hash of members"},
{ &xtra[684], XTRA_USAGE, "geohash key mem [mem ...]\n"},
{ &xtra[685], XTRA_DESCR,
"Get geo hash string by finding the members and converting the *Uber\n"
"H3* hash to an encoded hash string as described in on the geohash wiki\n"
"page: https://en.wikipedia.org/wiki/Geohash\n"},
{ NULL, XTRA_RETURN,
"An array of geohash strings, which may be *nil* if member is not\n"
"found.\n"},
{ &xtra[687], XTRA_SHORT, "get pos of members"},
{ &xtra[688], XTRA_USAGE, "geopos key [mem ...]\n"},
{ &xtra[689], XTRA_DESCR,
"Get geo positions of members as longitude, latitude pairs.\n"},
{ NULL, XTRA_RETURN,
"An array of positions or *null* if member is not found.\n"},
{ &xtra[691], XTRA_SHORT, "get member distance"},
{ &xtra[692], XTRA_USAGE, "geodist key mem1 mem2 [unit]\n"},
{ &xtra[693], XTRA_DESCR,
"Compute the distance in units between members.  Default unit is\n"
"meters, but km, feet, miles are accepted.\n"},
{ NULL, XTRA_RETURN,
"A decimal string representing the distance or *nil* when member is not\n"
"found.\n"},
{ &xtra[695], XTRA_SHORT, "get members in radius"},
{ &xtra[696], XTRA_USAGE,
"georadius key long lat rad m | k | ft | mi [withcoord] [withdist]\n"
" [withhash] [count n] [asc | desc] [storedist key]\n"},
{ &xtra[697], XTRA_DESCR,
"Get all members within a radius of position.  This iterates through\n"
"the set using the hash of longitude latitude as the starting point.\n"
"When the endpoints are found, the members are returned or stored.\n"
"When storedist is used, then the distance and members are stored in a\n"
"sorted set.\n"},
{ NULL, XTRA_RETURN,
"An array of members with optional distance, hash, and/or coordinates.\n"
"The hash is an integer used by the *Uber H3* library.\n"},
{ &xtra[699], XTRA_SHORT, "get members"},
{ &xtra[700], XTRA_USAGE,
"georadiusbymember key member rad m | k | ft | mi [withcoord]\n"
" [withdist] [withhash] [count n] [asc | desc] [storedist key]\n"},
{ &xtra[701], XTRA_DESCR,
"Similar to georadius, get all members within a radius of an existing\n"
"member.  This iterates through the set using the named member as the\n"
"starting point.  When the endpoints are found, the members are\n"
"returned or stored.  When storedist is used, then the distance and\n"
"members are stored in a sorted set.\n"},
{ NULL, XTRA_RETURN,
"An array of members with optional distance, hash, and/or coordinates.\n"
"The hash is an integer used by the *Uber H3* library.\n"},
{ &xtra[703], XTRA_SHORT, "add elems to hlog"},
{ &xtra[704], XTRA_USAGE, "pfadd key elem [elem ...]\n"},
{ &xtra[705], XTRA_EXAMPLE, "> pfadd hl 1 2 3 4 5 6\n"
"1\n"},
{ &xtra[706], XTRA_DESCR, "Add elems to hyperloglog table.\n"},
{ NULL, XTRA_RETURN,
"The integer *1* is returned when new elements are added, *0* is\n"
"returned when all elements are collisions or duplicates.\n"},
{ &xtra[708], XTRA_SHORT, "get hlog cardinality"},
{ &xtra[709], XTRA_USAGE, "pfcount key [key ...]\n"},
{ &xtra[710], XTRA_EXAMPLE, "> pfadd hl 1 2 3 4 5 6\n"
"1\n"
"> pfcount hl\n"
"6\n"},
{ &xtra[711], XTRA_DESCR,
"Get approximate cardinality of hyperloglog table.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the cardinality estimate.\n"},
{ &xtra[713], XTRA_SHORT, "merge multiple hlogs"},
{ &xtra[714], XTRA_USAGE, "pfmerge dkey skey [skey ...]\n"},
{ &xtra[715], XTRA_EXAMPLE,
"> pfadd hl 1 2 3 4 5 6 10\n"
"1\n"
"> pfcount hl\n"
"7\n"
"> pfadd hl2 1 2 3 4 5 6 7\n"
"1\n"
"> pfcount hl2\n"
"7\n"
"> pfmerge hl2 hl hl2\n"
"'OK'\n"
"> pfcount hl2\n"
"8\n"},
{ &xtra[716], XTRA_DESCR,
"Merge multiple hyperloglog tables and write them to the destination.\n"
"The dest key is not merged, it written to.  A dest key can be used as\n"
"a source key, but the original data in the source will be overwritten\n"
"with the merged data.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[718], XTRA_SHORT, "pattern subscribe"},
{ &xtra[719], XTRA_USAGE, "psubscribe pat [pat ...]\n"},
{ &xtra[720], XTRA_EXAMPLE,
"> psubscribe p* q*\n"
"executing: [\"psubscribe\",\"p*\",\"q*\"]\n"
"[\"psubscribe\",\"p*\",1]\n"
"[\"psubscribe\",\"q*\",2]\n"
"[\"pmessage\",\"p*\",\"publius\",\"friend\"]\n"
"[\"pmessage\",\"q*\",\"qQq\",\"OoO\"]\n"},
{ &xtra[721], XTRA_DESCR,
"Subscribe to patterns.  The messages published to channels which match\n"
"the pattern will be forwarded to the client.  A message may be\n"
"forwarded to the same client more than once if its channel matches\n"
"multiple patterns.  It is also possible to be forwarded the message\n"
"again if the channel matches a subscription.\n"},
{ NULL, XTRA_RETURN,
"An array with the subscription and an integer which is a count of the\n"
"subscriptions open.\n"},
{ &xtra[723], XTRA_SHORT, "query pubsub info"},
{ &xtra[724], XTRA_USAGE,
"pubsub [channels [pattern] | numsub channel | numpat]\n"},
{ &xtra[725], XTRA_EXAMPLE,
"> pubsub channels\n"
"[\"two\",\"five\",\"seven\",\"six\",\"one\",\"three\",\"four\"]\n"
"> pubsub channels t*\n"
"[\"two\",\"three\"]\n"
"> pubsub channels x*\n"
"[]\n"},
{ &xtra[726], XTRA_DESCR,
"Get the channels that are in use which match a pattern.\n"},
{ &xtra[727], XTRA_EXAMPLE,
"> pubsub numsub one two three\n"
"[\"one\",1,\"two\",1,\"three\",1]\n"},
{ &xtra[728], XTRA_DESCR,
"Get the number of subscription on each channel.\n"},
{ &xtra[729], XTRA_EXAMPLE, "> pubsub numpat\n"
"3\n"},
{ NULL, XTRA_DESCR,
"Display the number of pattern subscriptions open.\n"},
{ &xtra[731], XTRA_SHORT, "publish msg to channel"},
{ &xtra[732], XTRA_USAGE, "publish channel msg\n"},
{ &xtra[733], XTRA_EXAMPLE, "> publish one two\n"
"1\n"},
{ &xtra[734], XTRA_DESCR, "Publish msg to channel.\n"},
{ NULL, XTRA_RETURN,
"A count of the times the message is forwarded to a client.\n"},
{ &xtra[736], XTRA_SHORT, "pattern unsubscribe"},
{ &xtra[737], XTRA_USAGE, "punsubscribe [pat ...]\n"},
{ &xtra[738], XTRA_EXAMPLE,
"> psubscribe x*\n"
"[\"psubscribe\",\"x*\",1]\n"
"> punsubscribe x*\n"
"[\"punsubscribe\",\"x*\",0]\n"},
{ &xtra[739], XTRA_DESCR,
"Unsubscribe patterns.  This cancels interest in the patterns\n"
"previously subscribed.  If no patterns are named, all patterns are\n"
"unsubscribed.\n"},
{ NULL, XTRA_RETURN,
"An array with the punsubscribe and an integer count of the number of\n"
"subscriptions that the client has open.\n"},
{ &xtra[741], XTRA_SHORT, "subscribe channel"},
{ &xtra[742], XTRA_USAGE, "subscribe chan [chan ...]\n"},
{ &xtra[743], XTRA_EXAMPLE, "> subscribe x\n"
"[\"subscribe\",\"x\",1]\n"},
{ &xtra[744], XTRA_DESCR,
"Subscribe to channels.  The messages published to the channels that\n"
"are subscribed will be forwarded to the client.\n"},
{ NULL, XTRA_RETURN,
"An array with the subscription and an integer which is a count of the\n"
"subscriptions open.\n"},
{ &xtra[746], XTRA_SHORT, "unsubscribe channel"},
{ &xtra[747], XTRA_USAGE, "unsubscribe [chan ...]\n"},
{ &xtra[748], XTRA_EXAMPLE,
"> subscribe x\n"
"[\"subscribe\",\"x\",1]\n"
"> unsubscribe x\n"
"[\"unsubscribe\",\"x\",0]\n"},
{ &xtra[749], XTRA_DESCR,
"Unsubscribe channels.  This cancels interest in the channels\n"
"previously subscribed.  If no channels are named, all channels are\n"
"unsubscribed.\n"},
{ NULL, XTRA_RETURN,
"An array with the unsubscribe and an integer count of the number of\n"
"subscriptions that the client has open.\n"},
{ &xtra[751], XTRA_SHORT, "discard trans"},
{ &xtra[752], XTRA_USAGE, "discard \n"},
{ &xtra[753], XTRA_EXAMPLE,
"> multi\n"
"'OK'\n"
"> incr x\n"
"'QUEUED'\n"
"> discard\n"
"'OK'\n"},
{ &xtra[754], XTRA_DESCR,
"Discards watch commands and discards commands queued by multi.\n"},
{ NULL, XTRA_RETURN, "*OK* or error when no multi is started.\n"},
{ &xtra[756], XTRA_SHORT, "run trans"},
{ &xtra[757], XTRA_USAGE, "exec \n"},
{ &xtra[758], XTRA_EXAMPLE,
"> multi\n"
"'OK'\n"
"> set x 10\n"
"'QUEUED'\n"
"> exec\n"
"['OK']\n"},
{ &xtra[759], XTRA_DESCR,
"Execute commands queued by multi as an atomic unit.\n"},
{ NULL, XTRA_RETURN,
"An array of results, an element for every command, or *null* when a watch\n"
"fails.\n"},
{ &xtra[761], XTRA_SHORT, "start trans"},
{ &xtra[762], XTRA_USAGE, "multi \n"},
{ &xtra[763], XTRA_EXAMPLE,
"> multi\n"
"'OK'\n"
"> set x 10\n"
"'QUEUED'\n"
"> exec\n"
"['OK']\n"
"> multi\n"
"'OK'\n"
"> set\n"
"`ERR arguments format cmd: \\'set\\'`\n"
"> set x 10\n"
"'QUEUED'\n"
"> exec\n"
"`ERR transaction aborted, error cmd: \\'exec\\'`\n"},
{ &xtra[764], XTRA_DESCR,
"Start a transaction, commands issued after multi but before exec are\n"
"queued execution.  The syntax of the command and arguments is checked before\n"
"being queued, so a command may be *QUEUED* or have an syntax error result.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[766], XTRA_SHORT, "stop watching"},
{ &xtra[767], XTRA_USAGE, "unwatch \n"},
{ &xtra[768], XTRA_EXAMPLE, "> watch x\n"
"'OK'\n"
"> unwatch\n"
"'OK'\n"},
{ &xtra[769], XTRA_DESCR, "Discard watched keys.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[771], XTRA_SHORT, "start watching"},
{ &xtra[772], XTRA_USAGE, "watch key [key ...]\n"},
{ &xtra[773], XTRA_EXAMPLE,
"> watch x\n"
"'OK'\n"
"> multi\n"
"'OK'\n"
"> set x 10\n"
"'QUEUED'\n"
"> exec\n"
"null\n"},
{ &xtra[774], XTRA_DESCR,
"Watch keys before a multi transaction starts.  After exec is issued,\n"
"all watched keys are examined to make sure that none have been modified.  If a\n"
"watched key was modified, then the transaction aborts and *null* is returned.\n"},
{ NULL, XTRA_RETURN, "*OK*.\n"
"\n"},
{ &xtra[776], XTRA_SHORT, "get stream info"},
{ &xtra[777], XTRA_USAGE,
"xinfo [consumers key groupname] [groups key] [stream key]\n"},
{ &xtra[778], XTRA_EXAMPLE,
"> xinfo groups S\n"
"[[\"name\",\"G\",\"consumers\",2,\"pending\",2,\"last-delivered-id\",\n"
"  \"1580474523226-0\"],\n"
"[\"name\",\"H\",\"consumers\",0,\"pending\",0,\"last-delivered-id\",\"0\"]]\n"},
{ &xtra[779], XTRA_DESCR,
"Get group info for a stream, which shows what the next *id* will be,\n"
"the number of consumers and the number of pending records.\n"},
{ &xtra[780], XTRA_RETURN,
"An array of groups where each group is an array of field values:\n"
"\n"
"- name -- the name of the group.\n"
"- consumers -- the count of consumers.\n"
"- pending -- the count of records in the pending queue.\n"
"- last-delivered-id -- an *id* pointer, used to incrementally send\n"
"  newer records to clients.\n"
"\n"
"The empty array *[]* is returned when the stream doesn't exist or it\n"
"does not have groups.\n"},
{ &xtra[781], XTRA_EXAMPLE,
"> xinfo stream S\n"
"[\"length\",3,\"groups\",2,\"last-generated-id\",\"1580474524828-0\",\"first-entry\",\n"
"[\"1580474520477-0\",[\"c\",\"1\"]],\"last-entry\",[\"1580474524828-0\",[\"b\",\"1\"]]]\n"},
{ &xtra[782], XTRA_DESCR, "Get the info for the a stream.\n"},
{ &xtra[783], XTRA_RETURN,
"An array of field values describing the stream:\n"
"\n"
"- length -- the number of items in the stream\n"
"- groups -- the number of groups associated with the stream\n"
"- last-generated-id -- the *id* generated by the stream, it is used to\n"
"  ensure that the next generated *id* is greater than the last.\n"
"- first-entry -- the item which is at the head of the stream.\n"
"- last-entry -- the item which is at the tail of the stream.\n"
"\n"
"The empty array *[]* is returned when the stream doesn't exist.\n"},
{ &xtra[784], XTRA_EXAMPLE,
"> xinfo consumers S G\n"
"[[\"name\",\"C\",\"pending\",1,\"idle\",2225891],[\"name\",\"D\",\"pending\",1,\n"
"  \"idle\",2221204]]\n"},
{ NULL, XTRA_RETURN,
"An array of consumers, which is an array of field values:\n"
"\n"
"- name -- the name of the consumer.\n"
"- pending -- the count of records in the pending queue for this\n"
"  consumer.\n"
"- idle -- the number of milliseconds since the consumer was active\n"
"\n"
"The empty array *[]* is returned when stream or group or consumers\n"
"don't exist.\n"},
{ &xtra[786], XTRA_SHORT, "add entry to stream"},
{ &xtra[787], XTRA_USAGE, "xadd key id field string [field string ...]\n"},
{ &xtra[788], XTRA_EXAMPLE,
"> xadd S * cosmic crisp\n"
"\"1580392806377-0\"\n"
"> xadd S * red delicous\n"
"\"1580392886784-0\"\n"
"> xrange S - +\n"
"[[\"1580392806377-0\",[\"cosmic\",\"crisp\"]],\n"
" [\"1580392886784-0\",[\"red\",\"delicious\"]]]\n"},
{ &xtra[789], XTRA_DESCR,
"Add field value pairs to stream.  If *id* is the star, then it is\n"
"generated using the current milliseconds, and an incrementing serial\n"
"number which is only incremented within the millisecond period.  If\n"
"the *id* is not generated, it should be one or two 64 bit integers\n"
"(separated by the dash) increasing in value, since an *id* must formed\n"
"to increase over time.\n"},
{ NULL, XTRA_RETURN,
"The string *id* associated with the new entry.\n"},
{ &xtra[791], XTRA_SHORT, "trim stream to size"},
{ &xtra[792], XTRA_USAGE, "xtrim key maxlen [~] count\n"},
{ &xtra[793], XTRA_EXAMPLE,
"> xadd S * cosmic crisp\n"
"\"1580392806377-0\"\n"
"> xadd S * red delicous\n"
"\"1580392886784-0\"\n"
"> xadd S * shiba inu\n"
"\"1580393902456-0\"\n"
"> xadd S * akita inu\n"
"\"1580393946076-0\"\n"
"> xlen S\n"
"4\n"
"> xtrim S maxlen 2\n"
"2\n"
"> xrange S - +\n"
"[[\"1580393902456-0\",[\"shiba\",\"inu\"]],\n"
" [\"1580393946076-0\",[\"akita\",\"inu\"]]\n"},
{ &xtra[794], XTRA_DESCR,
"Trims the stream to a maxlen items from the tail -- these are the\n"
"oldest entries.\n"},
{ NULL, XTRA_RETURN,
"An integer count of items removed from the stream.\n"},
{ &xtra[796], XTRA_SHORT, "delete from stream"},
{ &xtra[797], XTRA_USAGE, "xdel key id [id ...]\n"},
{ &xtra[798], XTRA_EXAMPLE,
"> xadd S * hello world\n"
"\"1580394876047-0\"\n"
"> xadd S * hello world\n"
"\"1580394877281-0\"\n"
"> xdel S 1580394876047-0 1580394877281-0\n"
"2\n"},
{ &xtra[799], XTRA_DESCR,
"Delete entries from the stream which match the *id* strings.\n"},
{ NULL, XTRA_RETURN,
"An integer count of items removed from the stream.\n"},
{ &xtra[801], XTRA_SHORT, "get range of items"},
{ &xtra[802], XTRA_USAGE, "xrange key start end [count cnt]\n"},
{ &xtra[803], XTRA_EXAMPLE,
"> xadd S * a 1\n"
"\"1580458726320-0\"\n"
"> xadd S * b 2\n"
"\"1580458729687-0\"\n"
"> xadd S * c 3\n"
"\"1580458733903-0\"\n"
"> xrange S - +\n"
"[[\"1580458726320-0\",[\"a\",\"1\"]],[\"1580458729687-0\",[\"b\",\"2\"]],\n"
" [\"1580458733903-0\",[\"c\",\"3\"]]]\n"
"> xrange S 1580458729687 1580458733903\n"
"[[\"1580458729687-0\",[\"b\",\"2\"]],[\"1580458733903-0\",[\"c\",\"3\"]]]\n"
"> xrange S 1580458733903-1 +\n"
"[]\n"},
{ &xtra[804], XTRA_DESCR,
"Get items between start and end range.  The *id* assigned to each item\n"
"in the stream is a numerically increasing value.  The start is the low\n"
"*id*, the end is the high *id*.  All of the items within the range are\n"
"returned, up to count, if specified.\n"},
{ NULL, XTRA_RETURN,
"An array of items.  Each item is an *id* followed by an array of all\n"
"of the fields defined in the entry.  The empty array is the result\n"
"when no items are found or the key does not exist.\n"},
{ &xtra[806], XTRA_SHORT, "get reverse range"},
{ &xtra[807], XTRA_USAGE, "xrevrange key start end [count cnt]\n"},
{ &xtra[808], XTRA_EXAMPLE,
"> xadd S * a 1\n"
"\"1580458726320-0\"\n"
"> xadd S * b 2\n"
"\"1580458729687-0\"\n"
"> xadd S * c 3\n"
"\"1580458733903-0\"\n"
"> xrevrange S + -\n"
"[[\"1580458733903-0\",[\"c\",\"3\"]],[\"1580458729687-0\",[\"b\",\"2\"]],\n"
" [\"1580458726320-0\",[\"a\",\"1\"]]]\n"
"> xrevrange S 1580458733903 1580458729687\n"
"[[\"1580458733903-0\",[\"c\",\"3\"]],[\"1580458729687-0\",[\"b\",\"2\"]]]\n"
"> xrevrange S + 1580458733903-1\n"
"[]\n"},
{ &xtra[809], XTRA_DESCR,
"Get items between start and end range.  The *id* assigned to each item\n"
"in the stream is a numerically increasing value.  The start is the\n"
"high *id*, the end is the low *id*.  All of the items within the range\n"
"are returned, up to count, if specified.\n"},
{ NULL, XTRA_RETURN,
"An array of items.  Each item is an *id* followed by an array of all\n"
"of the fields defined in the entry.  The empty array is the result\n"
"when no items are found or the key does not exist.\n"},
{ &xtra[811], XTRA_SHORT, "get stream length"},
{ &xtra[812], XTRA_USAGE, "xlen key\n"},
{ &xtra[813], XTRA_EXAMPLE,
"> xadd S * a 1\n"
"\"1580458726320-0\"\n"
"> xlen S\n"
"1\n"
"> xadd S * b 2\n"
"\"1580458729687-0\"\n"
"> xlen S\n"
"2\n"},
{ &xtra[814], XTRA_DESCR, "Get the number of items in a stream.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of items, or *0* when the stream is\n"
"empty or the key doesn't exist.\n"},
{ &xtra[816], XTRA_SHORT, "get next entry"},
{ &xtra[817], XTRA_USAGE,
"xread [count cnt] [block ms] streams key [key ...] id [id ...]\n"},
{ &xtra[818], XTRA_EXAMPLE,
"> xadd S * a 1\n"
"\"1580466119503-0\"\n"
"> xadd T * x 1\n"
"\"1580466126059-0\"\n"
"> xread streams S T 0 0\n"
"[[\"S\",[[\"1580466119503-0\",[\"a\",\"1\"]]]],\n"
" [\"T\",[[\"1580466126059-0\",[\"x\",\"1\"]]]]]\n"},
{ &xtra[819], XTRA_DESCR,
"Read new items on one or more streams which occur after the *id*.  If\n"
"all streams are exhausted of new items, then the command can block, if\n"
"requested, until items are available on any stream.\n"},
{ NULL, XTRA_RETURN,
"An array of streams names that have items, with the array of item\n"
"identfiers, then the array of field values.  The result is\n"
"structurally similar to the xrange command, where the results are\n"
"combined over multiple streams.  If no items are available, or the\n"
"block timeout expires, a *null* is returned.\n"},
{ &xtra[821], XTRA_SHORT, "modify group"},
{ &xtra[822], XTRA_USAGE,
"xgroup [create key grp id [mkstream]] [setid key grp id]\n"
" [destroy key grp] [delconsumer key grp cname]\n"},
{ &xtra[823], XTRA_EXAMPLE,
"> xgroup create S G 0 mkstream\n"
"'OK'\n"
"> xgroup create T G 0 mkstream\n"
"'OK'\n"
"> xadd S * a 1\n"
"\"1580466848853-0\"\n"
"> xadd T * x 1\n"
"\"1580466970348-0\"\n"
"> xreadgroup group G C streams S T > >\n"
"[[\"S\",[[\"1580466848853-0\",[\"a\",\"1\"]]]],\n"
" [\"T\",[[\"1580466970348-0\",[\"x\",\"1\"]]]]]\n"},
{ &xtra[824], XTRA_DESCR,
"Create a consumer group and initialize the next id that consumers will\n"
"read.  The option mkstream will create an empty stream if it doesn't\n"
"exit.\n"},
{ &xtra[825], XTRA_EXAMPLE,
"> xgroup setid S G 0\n"
"'OK'\n"
"> xreadgroup group G D streams S T > >\n"
"[[\"S\",[[\"1580466848853-0\",[\"a\",\"1\"]]]]]\n"},
{ &xtra[826], XTRA_DESCR,
"Set the next id that consumers will read.  Each group contains a\n"
"pointer to the next id.  The setid argument moves the pointer to a\n"
"different location.\n"},
{ &xtra[827], XTRA_EXAMPLE,
"> xinfo groups T\n"
"[[\"name\",\"G\",\"consumers\",1,\"pending\",1,\n"
"  \"last-delivered-id\",\"1580466970348-0\"]]\n"
"> xgroup destroy T G\n"
"1\n"
"> xinfo groups T\n"
"[]\n"},
{ &xtra[828], XTRA_DESCR,
"Destroy the group and associated consumers from the stream.\n"},
{ &xtra[829], XTRA_EXAMPLE,
"> xinfo consumers S G\n"
"[[\"name\",\"C\",\"pending\",1,\"idle\",466329],\n"
" [\"name\",\"D\",\"pending\",1,\"idle\",378057]]\n"
"> xgroup delconsumer S G D\n"
"1\n"
"> xinfo consumers S G\n"
"[[\"name\",\"C\",\"pending\",1,\"idle\",514499]]\n"},
{ &xtra[830], XTRA_DESCR,
"Delete the consumer from the group.  The removes any pending items\n"
"that the consumer has outstanding.\n"},
{ NULL, XTRA_RETURN,
"- xgroup create -- *OK* or error if key not found and mkstream not\n"
"  specified.\n"
"- xgroup setid -- *OK* or error if group or key not found.\n"
"- xgroup destroy -- An integer *1* if group destroyed, *0* if not\n"
"  found.\n"
"- xgroup delconsumer -- An integer *1* if consumer destroyed, *0* if\n"
"  not found.\n"},
{ &xtra[832], XTRA_SHORT, "read next group"},
{ &xtra[833], XTRA_USAGE,
"xreadgroup group grp consumer [count cnt] [block ms] [noack]\n"
" streams key [key ...] id [id ...]\n"},
{ &xtra[834], XTRA_EXAMPLE,
"> xadd S * a 1\n"
"\"1580466848853-0\"\n"
"> xadd T * x 1\n"
"\"1580466970348-0\"\n"
"> xreadgroup group G C streams S T > >\n"
"[[\"S\",[[\"1580466848853-0\",[\"a\",\"1\"]]]],\n"
" [\"T\",[[\"1580466970348-0\",[\"x\",\"1\"]]]]]\n"
"> xpending S G\n"
"[1,\"1580466848853-0\",\"1580466848853-0\",[[\"C\",\"1\"]]]\n"
"> xpending T G\n"
"[1,\"1580466970348-0\",\"1580466970348-0\",[[\"C\",\"1\"]]]\n"
"> xack S G 1580466848853-0\n"
"1\n"
"> xack T G 1580466970348-0\n"
"1\n"
"> xpending S G\n"
"[0,nil,nil,nil]\n"
"> xpending T G\n"
"[0,nil,nil,nil]\n"},
{ &xtra[835], XTRA_DESCR,
"Read streams through consumer group.  This assigns items from the\n"
"stream to the consumer attached to the group.  A record of this read\n"
"is saved with the stream until it is acked with xack, or reassigned\n"
"with xclaim, or the group is destroyed with xgroup.  If the *id* used\n"
"to read the streams is *>*, then the next id pointer for the group is\n"
"used to read the next available items.  If the *id* is a number, then\n"
"the records returned are already assigned to the consumer.  This form\n"
"is used to find the records after they have been delivered.  If no\n"
"records are available and *>* is used, then *null* is returned or if\n"
"block ms is used, the command is blocked until the records become\n"
"available.\n"},
{ NULL, XTRA_RETURN,
"An array of streams names that have items, with the array of item\n"
"identfiers, then the array of field values.  The result is\n"
"structurally similar to the xrange command, where the results are\n"
"combined over multiple streams.  If no items are available, or the\n"
"block timeout expires, a *null* is returned.\n"},
{ &xtra[837], XTRA_SHORT, "consume group entry"},
{ &xtra[838], XTRA_USAGE, "xack key grp id [id ...]\n"},
{ &xtra[839], XTRA_EXAMPLE,
"> xreadgroup group G C streams S >\n"
"[[\"S\",[[\"1580466848853-0\",[\"a\",\"1\"]]]]]\n"
"> xpending S G\n"
"[1,\"1580466848853-0\",\"1580466848853-0\",[[\"C\",\"1\"]]]\n"
"> xack S G 1580466848853-0\n"
"1\n"
"> xpending S G\n"
"[0,nil,nil,nil]\n"
"> xack S G 1580466848853-0\n"
"0\n"},
{ &xtra[840], XTRA_DESCR,
"Acknowledge consumption of the *id* strings.  The record in the stream\n"
"associated with the group is removed from the pending list.\n"},
{ NULL, XTRA_RETURN,
"An integer count of the number of *id* strings acked.\n"},
{ &xtra[842], XTRA_SHORT, "read old group entries"},
{ &xtra[843], XTRA_USAGE,
"xclaim key grp consumer min-idle-time id [id ...] [idle ms]\n"
"[time ms-utc] [retrycount cnt] [force] [justid]\n"},
{ &xtra[844], XTRA_EXAMPLE,
"> xreadgroup group G C streams S >\n"
"[[\"S\",[[\"1580466848853-0\",[\"a\",\"1\"]]]]]\n"
"> xclaim S G D 1 1580466848853-0\n"
"[[\"1580466848853-0\",[\"a\",\"1\"]]]\n"
"> xpending S G\n"
"[1,\"1580466848853-0\",\"1580466848853-0\",[[\"D\",\"1\"]]]\n"
"> xack S G 1580466848853-0\n"
"1\n"
"> xpending S G\n"
"[0,nil,nil,nil]\n"
"> xgroup setid S G 0\n"
"'OK'\n"
"> xclaim S G D 1 1580466848853-0\n"
"[]\n"
"> xreadgroup group G C streams S >\n"
"[[\"S\",[[\"1580466848853-0\",[\"a\",\"1\"]]]]]\n"
"> xclaim S G D 10000 1580466848853-0\n"
"[]\n"
"> xclaim S G D 100 1580466848853-0\n"
"[[\"1580466848853-0\",[\"a\",\"1\"]]]\n"
"> xclaim S G E 0 1580466848853-0 force\n"
"[[\"1580466848853-0\",[\"a\",\"1\"]]]\n"
"> xclaim S G X 0 1580466848853-0 force justid\n"
"[\"1580466848853-0\"]\n"
"> xpending S G\n"
"[1,\"1580466848853-0\",\"1580466848853-0\",[[\"X\",\"1\"]]]\n"},
{ &xtra[845], XTRA_DESCR,
"Recover items from a stream, group and assign them to a consumer.  An\n"
"item must be older than min-idle-time millisecs in order for xclaim to\n"
"succeed.  This is to prevent the race condtion of claiming items that\n"
"were already claimed.  The force argument causes the record to be\n"
"claimed regardless of the pending state.\n"},
{ NULL, XTRA_RETURN,
"The records are returned when xclaim succeeds, unless justid is\n"
"specified.  An empty array is returned when no *id* succeeds.\n"},
{ &xtra[847], XTRA_SHORT, "find pending by group"},
{ &xtra[848], XTRA_USAGE,
"xpending key grp [start end count] [consumer]\n"},
{ &xtra[849], XTRA_EXAMPLE,
"> xpending S G\n"
"[1,\"1580466848853-0\",\"1580466848853-0\",[[\"X\",\"1\"]]]\n"
"> xreadgroup group G C count 1 streams S >\n"
"[[\"S\",[[\"1580472282479-0\",[\"b\",\"1\"]]]]]\n"
"> xreadgroup group G D count 1 streams S >\n"
"[[\"S\",[[\"1580472289614-0\",[\"c\",\"1\"]]]]]\n"
"> xpending S G\n"
"[3,\"1580466848853-0\",\"1580472289614-0\",\n"
" [[\"X\",\"1\"],[\"C\",\"1\"],[\"D\",\"1\"]]]\n"
"> xpending S G - + 10 C\n"
"[[\"1580472282479-0\",\"C\",73749,1]]\n"
"> xpending S G - + 10 D\n"
"[[\"1580472289614-0\",\"D\",77612,1]]\n"
"> xadd S * d 1\n"
"\"1580472723272-0\"\n"
"> xreadgroup group G D count 1 streams S >\n"
"[[\"S\",[[\"1580472723272-0\",[\"d\",\"1\"]]]]]\n"
"> xpending S G - + 10 D\n"
"[[\"1580472289614-0\",\"D\",397783,1],[\"1580472723272-0\",\"D\",4319,1]]\n"
"> xpending S G\n"
"[4,\"1580466848853-0\",\"1580472723272-0\",\n"
" [[\"X\",\"1\"],[\"C\",\"1\"],[\"D\",\"2\"]]]\n"},
{ &xtra[850], XTRA_DESCR,
"Get the pending *id* records from group.  Without a consumer, this\n"
"requests the number of pending records, pending head and tail for the\n"
"group, and the consumers pending count pairs.  With the consumer, this\n"
"requests all of the pending records for the consumer, up to the count\n"
"specified.  The id, the consumer, the pending time in milliseconds,\n"
"and the delivered count are in each of the pending records.\n"},
{ NULL, XTRA_RETURN,
"- xpending key grp -- An array of pending count, head pending *id*,\n"
"  tail pending *id*, and an array off consumers, each with a count of\n"
"  pending records.\n"
"- xpending key grp start end count consumer -- An array of pending\n"
"  records belonging to the consumer requested, each with an *id*, an\n"
"  idle time, and a delivery count.\n"},
{ &xtra[852], XTRA_SHORT, "set last entry of group"},
{ &xtra[853], XTRA_USAGE, "xsetid key grp id\n"},
{ &xtra[854], XTRA_EXAMPLE,
"> xinfo groups S\n"
"[[\"name\",\"G\",\"consumers\",0,\"pending\",0,\n"
"  \"last-delivered-id\",\"1580474520477-0\"]]\n"
"> xsetid S G 0\n"
"'OK'\n"
"> xinfo groups S\n"
"[[\"name\",\"G\",\"consumers\",0,\"pending\",0,\"last-delivered-id\",\"0\"]]\n"},
{ &xtra[855], XTRA_DESCR,
"Set the next *id* of a group associated with a stream.\n"},
{ NULL, XTRA_RETURN,
"*OK* if success, error when key or group doesn't exist.\n"},
};
#endif
}
}
#endif
#endif
